#!/usr/bin/perl

# $Id: dspam.cgi,v 1.02 2011/06/28 00:13:48 sbajic Exp $
# DSPAM
# COPYRIGHT (C) 2002-2012 DSPAM PROJECT
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

sub htmlize_chars {
  #
  # Replace some characters to HTML entities
  #
  my($text)=@_;
  my %html=();
  $html{'A0'}='&nbsp;';
  $html{'A1'}='&iexcl;';
  $html{'A2'}='&cent;';
  $html{'A3'}='&pound;';
  $html{'A4'}='&curren;';
  $html{'A5'}='&yen;';
  $html{'A6'}='&brvbar;';
  $html{'A7'}='&sect;';
  $html{'A8'}='&uml;';
  $html{'A9'}='&copy;';
  $html{'AA'}='&ordf;';
  $html{'AB'}='&laquo;';
  $html{'AC'}='&not;';
  $html{'AD'}='&shy;';
  $html{'AE'}='&reg;';
  $html{'AF'}='&macr;';
  $html{'B0'}='&deg;';
  $html{'B1'}='&plusmn;';
  $html{'B2'}='&sup2;';
  $html{'B3'}='&sup3;';
  $html{'B4'}='&acute;';
  $html{'B5'}='&micro;';
  $html{'B6'}='&para;';
  $html{'B7'}='&middot;';
  $html{'B8'}='&cedil;';
  $html{'B9'}='&sup1;';
  $html{'BA'}='&ordm;';
  $html{'BB'}='&raquo;';
  $html{'BC'}='&frac14;';
  $html{'BD'}='&frac12;';
  $html{'BE'}='&frac34;';
  $html{'BF'}='&iquest;';
  $html{'C0'}='&Agrave;';
  $html{'C1'}='&Aacute;';
  $html{'C2'}='&Acirc;';
  $html{'C3'}='&Atilde;';
  $html{'C4'}='&Auml;';
  $html{'C5'}='&Aring;';
  $html{'C6'}='&AElig;';
  $html{'C7'}='&Ccedil;';
  $html{'C8'}='&Egrave;';
  $html{'C9'}='&Eacute;';
  $html{'CA'}='&Ecirc;';
  $html{'CB'}='&Euml;';
  $html{'CC'}='&Igrave;';
  $html{'CD'}='&Iacute;';
  $html{'CE'}='&Icirc;';
  $html{'CF'}='&Iuml;';
  $html{'D0'}='&ETH;';
  $html{'D1'}='&Ntilde;';
  $html{'D2'}='&Ograve;';
  $html{'D3'}='&Oacute;';
  $html{'D4'}='&Ocirc;';
  $html{'D5'}='&Otilde;';
  $html{'D6'}='&Ouml;';
  $html{'D7'}='&times;';
  $html{'D8'}='&Oslash;';
  $html{'D9'}='&Ugrave;';
  $html{'DA'}='&Uacute;';
  $html{'DB'}='&Ucirc;';
  $html{'DC'}='&Uuml;';
  $html{'DD'}='&Yacute;';
  $html{'DE'}='&THORN;';
  $html{'DF'}='&szlig;';
  $html{'E0'}='&agrave;';
  $html{'E1'}='&aacute;';
  $html{'E2'}='&acirc;';
  $html{'E3'}='&atilde;';
  $html{'E4'}='&auml;';
  $html{'E5'}='&aring;';
  $html{'E6'}='&aelig;';
  $html{'E7'}='&ccedil;';
  $html{'E8'}='&egrave;';
  $html{'E9'}='&eacute;';
  $html{'EA'}='&ecirc;';
  $html{'EB'}='&euml;';
  $html{'EC'}='&igrave;';
  $html{'ED'}='&iacute;';
  $html{'EE'}='&icirc;';
  $html{'EF'}='&iuml;';
  $html{'F0'}='&eth;';
  $html{'F1'}='&ntilde;';
  $html{'F2'}='&ograve;';
  $html{'F3'}='&oacute;';
  $html{'F4'}='&ocirc;';
  $html{'F5'}='&otilde;';
  $html{'F6'}='&ouml;';
  $html{'F7'}='&divide;';
  $html{'F8'}='&oslash;';
  $html{'F9'}='&ugrave;';
  $html{'FA'}='&uacute;';
  $html{'FB'}='&ucirc;';
  $html{'FC'}='&uuml;';
  $html{'FD'}='&yacute;';
  $html{'FE'}='&thorn;';
  $html{'FF'}='&yuml;';

  my %map=();
  $map{'\\xC4\\x80'}='&#x100;';
  $map{'\\xC4\\x81'}='&#x101;';
  $map{'\\xC4\\x82'}='&#x102;';
  $map{'\\xC4\\x83'}='&#x103;';
  $map{'\\xC4\\x84'}='&#x104;';
  $map{'\\xC4\\x85'}='&#x105;';
  $map{'\\xC4\\x86'}='&#x106;';
  $map{'\\xC4\\x87'}='&#x107;';
  $map{'\\xC4\\x88'}='&#x108;';
  $map{'\\xC4\\x89'}='&#x109;';
  $map{'\\xC4\\x8A'}='&#x10A;';
  $map{'\\xC4\\x8B'}='&#x10B;';
  $map{'\\xC4\\x8C'}='&#x10C;';
  $map{'\\xC4\\x8D'}='&#x10D;';
  $map{'\\xC4\\x8E'}='&#x10E;';
  $map{'\\xC4\\x8F'}='&#x10F;';
  $map{'\\xC4\\x90'}='&#x110;';
  $map{'\\xC4\\x91'}='&#x111;';
  $map{'\\xC4\\x92'}='&#x112;';
  $map{'\\xC4\\x93'}='&#x113;';
  $map{'\\xC4\\x94'}='&#x114;';
  $map{'\\xC4\\x95'}='&#x115;';
  $map{'\\xC4\\x96'}='&#x116;';
  $map{'\\xC4\\x97'}='&#x117;';
  $map{'\\xC4\\x98'}='&#x118;';
  $map{'\\xC4\\x99'}='&#x119;';
  $map{'\\xC4\\x9A'}='&#x11A;';
  $map{'\\xC4\\x9B'}='&#x11B;';
  $map{'\\xC4\\x9C'}='&#x11C;';
  $map{'\\xC4\\x9D'}='&#x11D;';
  $map{'\\xC4\\x9E'}='&#x11E;';
  $map{'\\xC4\\x9F'}='&#x11F;';
  $map{'\\xC4\\xA0'}='&#x120;';
  $map{'\\xC4\\xA1'}='&#x121;';
  $map{'\\xC4\\xA2'}='&#x122;';
  $map{'\\xC4\\xA3'}='&#x123;';
  $map{'\\xC4\\xA4'}='&#x124;';
  $map{'\\xC4\\xA5'}='&#x125;';
  $map{'\\xC4\\xA6'}='&#x126;';
  $map{'\\xC4\\xA7'}='&#x127;';
  $map{'\\xC4\\xA8'}='&#x128;';
  $map{'\\xC4\\xA9'}='&#x129;';
  $map{'\\xC4\\xAA'}='&#x12A;';
  $map{'\\xC4\\xAB'}='&#x12B;';
  $map{'\\xC4\\xAC'}='&#x12C;';
  $map{'\\xC4\\xAD'}='&#x12D;';
  $map{'\\xC4\\xAE'}='&#x12E;';
  $map{'\\xC4\\xAF'}='&#x12F;';
  $map{'\\xC4\\xB0'}='&#x130;';
  $map{'\\xC4\\xB1'}='&#x131;';
  $map{'\\xC4\\xB2'}='&#x132;';
  $map{'\\xC4\\xB3'}='&#x133;';
  $map{'\\xC4\\xB4'}='&#x134;';
  $map{'\\xC4\\xB5'}='&#x135;';
  $map{'\\xC4\\xB6'}='&#x136;';
  $map{'\\xC4\\xB7'}='&#x137;';
  $map{'\\xC4\\xB8'}='&#x138;';
  $map{'\\xC4\\xB9'}='&#x139;';
  $map{'\\xC4\\xBA'}='&#x13A;';
  $map{'\\xC4\\xBB'}='&#x13B;';
  $map{'\\xC4\\xBC'}='&#x13C;';
  $map{'\\xC4\\xBD'}='&#x13D;';
  $map{'\\xC4\\xBE'}='&#x13E;';
  $map{'\\xC4\\xBF'}='&#x13F;';
  $map{'\\xC5\\x80'}='&#x140;';
  $map{'\\xC5\\x81'}='&#x141;';
  $map{'\\xC5\\x82'}='&#x142;';
  $map{'\\xC5\\x83'}='&#x143;';
  $map{'\\xC5\\x84'}='&#x144;';
  $map{'\\xC5\\x85'}='&#x145;';
  $map{'\\xC5\\x86'}='&#x146;';
  $map{'\\xC5\\x87'}='&#x147;';
  $map{'\\xC5\\x88'}='&#x148;';
  $map{'\\xC5\\x89'}='&#x149;';
  $map{'\\xC5\\x8A'}='&#x14A;';
  $map{'\\xC5\\x8B'}='&#x14B;';
  $map{'\\xC5\\x8C'}='&#x14C;';
  $map{'\\xC5\\x8D'}='&#x14D;';
  $map{'\\xC5\\x8E'}='&#x14E;';
  $map{'\\xC5\\x8F'}='&#x14F;';
  $map{'\\xC5\\x90'}='&#x150;';
  $map{'\\xC5\\x91'}='&#x151;';
  $map{'\\xC5\\x92'}='&#x152;';
  $map{'\\xC5\\x93'}='&#x153;';
  $map{'\\xC5\\x94'}='&#x154;';
  $map{'\\xC5\\x95'}='&#x155;';
  $map{'\\xC5\\x96'}='&#x156;';
  $map{'\\xC5\\x97'}='&#x157;';
  $map{'\\xC5\\x98'}='&#x158;';
  $map{'\\xC5\\x99'}='&#x159;';
  $map{'\\xC5\\x9A'}='&#x15A;';
  $map{'\\xC5\\x9B'}='&#x15B;';
  $map{'\\xC5\\x9C'}='&#x15C;';
  $map{'\\xC5\\x9D'}='&#x15D;';
  $map{'\\xC5\\x9E'}='&#x15E;';
  $map{'\\xC5\\x9F'}='&#x15F;';
  $map{'\\xC5\\xA0'}='&#x160;';
  $map{'\\xC5\\xA1'}='&#x161;';
  $map{'\\xC5\\xA2'}='&#x162;';
  $map{'\\xC5\\xA3'}='&#x163;';
  $map{'\\xC5\\xA4'}='&#x164;';
  $map{'\\xC5\\xA5'}='&#x165;';
  $map{'\\xC5\\xA6'}='&#x166;';
  $map{'\\xC5\\xA7'}='&#x167;';
  $map{'\\xC5\\xA8'}='&#x168;';
  $map{'\\xC5\\xA9'}='&#x169;';
  $map{'\\xC5\\xAA'}='&#x16A;';
  $map{'\\xC5\\xAB'}='&#x16B;';
  $map{'\\xC5\\xAC'}='&#x16C;';
  $map{'\\xC5\\xAD'}='&#x16D;';
  $map{'\\xC5\\xAE'}='&#x16E;';
  $map{'\\xC5\\xAF'}='&#x16F;';
  $map{'\\xC5\\xB0'}='&#x170;';
  $map{'\\xC5\\xB1'}='&#x171;';
  $map{'\\xC5\\xB2'}='&#x172;';
  $map{'\\xC5\\xB3'}='&#x173;';
  $map{'\\xC5\\xB4'}='&#x174;';
  $map{'\\xC5\\xB5'}='&#x175;';
  $map{'\\xC5\\xB6'}='&#x176;';
  $map{'\\xC5\\xB7'}='&#x177;';
  $map{'\\xC5\\xB8'}='&#x178;';
  $map{'\\xC5\\xB9'}='&#x179;';
  $map{'\\xC5\\xBA'}='&#x17A;';
  $map{'\\xC5\\xBB'}='&#x17B;';
  $map{'\\xC5\\xBC'}='&#x17C;';
  $map{'\\xC5\\xBD'}='&#x17D;';
  $map{'\\xC5\\xBE'}='&#x17E;';
  $map{'\\xC5\\xBF'}='&#x17F;';
  $map{'\\xC6\\x80'}='&#x180;';
  $map{'\\xC6\\x81'}='&#x181;';
  $map{'\\xC6\\x82'}='&#x182;';
  $map{'\\xC6\\x83'}='&#x183;';
  $map{'\\xC6\\x84'}='&#x184;';
  $map{'\\xC6\\x85'}='&#x185;';
  $map{'\\xC6\\x86'}='&#x186;';
  $map{'\\xC6\\x87'}='&#x187;';
  $map{'\\xC6\\x88'}='&#x188;';
  $map{'\\xC6\\x89'}='&#x189;';
  $map{'\\xC6\\x8A'}='&#x18A;';
  $map{'\\xC6\\x8B'}='&#x18B;';
  $map{'\\xC6\\x8C'}='&#x18C;';
  $map{'\\xC6\\x8D'}='&#x18D;';
  $map{'\\xC6\\x8E'}='&#x18E;';
  $map{'\\xC6\\x8F'}='&#x18F;';
  $map{'\\xC6\\x90'}='&#x190;';
  $map{'\\xC6\\x91'}='&#x191;';
  $map{'\\xC6\\x92'}='&#x192;';
  $map{'\\xC6\\x93'}='&#x193;';
  $map{'\\xC6\\x94'}='&#x194;';
  $map{'\\xC6\\x95'}='&#x195;';
  $map{'\\xC6\\x96'}='&#x196;';
  $map{'\\xC6\\x97'}='&#x197;';
  $map{'\\xC6\\x98'}='&#x198;';
  $map{'\\xC6\\x99'}='&#x199;';
  $map{'\\xC6\\x9A'}='&#x19A;';
  $map{'\\xC6\\x9B'}='&#x19B;';
  $map{'\\xC6\\x9C'}='&#x19C;';
  $map{'\\xC6\\x9D'}='&#x19D;';
  $map{'\\xC6\\x9E'}='&#x19E;';
  $map{'\\xC6\\x9F'}='&#x19F;';
  $map{'\\xC6\\xA0'}='&#x1A0;';
  $map{'\\xC6\\xA1'}='&#x1A1;';
  $map{'\\xC6\\xA2'}='&#x1A2;';
  $map{'\\xC6\\xA3'}='&#x1A3;';
  $map{'\\xC6\\xA4'}='&#x1A4;';
  $map{'\\xC6\\xA5'}='&#x1A5;';
  $map{'\\xC6\\xA6'}='&#x1A6;';
  $map{'\\xC6\\xA7'}='&#x1A7;';
  $map{'\\xC6\\xA8'}='&#x1A8;';
  $map{'\\xC6\\xA9'}='&#x1A9;';
  $map{'\\xC6\\xAA'}='&#x1AA;';
  $map{'\\xC6\\xAB'}='&#x1AB;';
  $map{'\\xC6\\xAC'}='&#x1AC;';
  $map{'\\xC6\\xAD'}='&#x1AD;';
  $map{'\\xC6\\xAE'}='&#x1AE;';
  $map{'\\xC6\\xAF'}='&#x1AF;';
  $map{'\\xC6\\xB0'}='&#x1B0;';
  $map{'\\xC6\\xB1'}='&#x1B1;';
  $map{'\\xC6\\xB2'}='&#x1B2;';
  $map{'\\xC6\\xB3'}='&#x1B3;';
  $map{'\\xC6\\xB4'}='&#x1B4;';
  $map{'\\xC6\\xB5'}='&#x1B5;';
  $map{'\\xC6\\xB6'}='&#x1B6;';
  $map{'\\xC6\\xB7'}='&#x1B7;';
  $map{'\\xC6\\xB8'}='&#x1B8;';
  $map{'\\xC6\\xB9'}='&#x1B9;';
  $map{'\\xC6\\xBA'}='&#x1BA;';
  $map{'\\xC6\\xBB'}='&#x1BB;';
  $map{'\\xC6\\xBC'}='&#x1BC;';
  $map{'\\xC6\\xBD'}='&#x1BD;';
  $map{'\\xC6\\xBE'}='&#x1BE;';
  $map{'\\xC6\\xBF'}='&#x1BF;';
  $map{'\\xC7\\x80'}='&#x1C0;';
  $map{'\\xC7\\x81'}='&#x1C1;';
  $map{'\\xC7\\x82'}='&#x1C2;';
  $map{'\\xC7\\x83'}='&#x1C3;';
  $map{'\\xC7\\x84'}='&#x1C4;';
  $map{'\\xC7\\x85'}='&#x1C5;';
  $map{'\\xC7\\x86'}='&#x1C6;';
  $map{'\\xC7\\x87'}='&#x1C7;';
  $map{'\\xC7\\x88'}='&#x1C8;';
  $map{'\\xC7\\x89'}='&#x1C9;';
  $map{'\\xC7\\x8A'}='&#x1CA;';
  $map{'\\xC7\\x8B'}='&#x1CB;';
  $map{'\\xC7\\x8C'}='&#x1CC;';
  $map{'\\xC7\\x8D'}='&#x1CD;';
  $map{'\\xC7\\x8E'}='&#x1CE;';
  $map{'\\xC7\\x8F'}='&#x1CF;';
  $map{'\\xC7\\x90'}='&#x1D0;';
  $map{'\\xC7\\x91'}='&#x1D1;';
  $map{'\\xC7\\x92'}='&#x1D2;';
  $map{'\\xC7\\x93'}='&#x1D3;';
  $map{'\\xC7\\x94'}='&#x1D4;';
  $map{'\\xC7\\x95'}='&#x1D5;';
  $map{'\\xC7\\x96'}='&#x1D6;';
  $map{'\\xC7\\x97'}='&#x1D7;';
  $map{'\\xC7\\x98'}='&#x1D8;';
  $map{'\\xC7\\x99'}='&#x1D9;';
  $map{'\\xC7\\x9A'}='&#x1DA;';
  $map{'\\xC7\\x9B'}='&#x1DB;';
  $map{'\\xC7\\x9C'}='&#x1DC;';
  $map{'\\xC7\\x9D'}='&#x1DD;';
  $map{'\\xC7\\x9E'}='&#x1DE;';
  $map{'\\xC7\\x9F'}='&#x1DF;';
  $map{'\\xC7\\xA0'}='&#x1E0;';
  $map{'\\xC7\\xA1'}='&#x1E1;';
  $map{'\\xC7\\xA2'}='&#x1E2;';
  $map{'\\xC7\\xA3'}='&#x1E3;';
  $map{'\\xC7\\xA4'}='&#x1E4;';
  $map{'\\xC7\\xA5'}='&#x1E5;';
  $map{'\\xC7\\xA6'}='&#x1E6;';
  $map{'\\xC7\\xA7'}='&#x1E7;';
  $map{'\\xC7\\xA8'}='&#x1E8;';
  $map{'\\xC7\\xA9'}='&#x1E9;';
  $map{'\\xC7\\xAA'}='&#x1EA;';
  $map{'\\xC7\\xAB'}='&#x1EB;';
  $map{'\\xC7\\xAC'}='&#x1EC;';
  $map{'\\xC7\\xAD'}='&#x1ED;';
  $map{'\\xC7\\xAE'}='&#x1EE;';
  $map{'\\xC7\\xAF'}='&#x1EF;';
  $map{'\\xC7\\xB0'}='&#x1F0;';
  $map{'\\xC7\\xB1'}='&#x1F1;';
  $map{'\\xC7\\xB2'}='&#x1F2;';
  $map{'\\xC7\\xB3'}='&#x1F3;';
  $map{'\\xC7\\xB4'}='&#x1F4;';
  $map{'\\xC7\\xB5'}='&#x1F5;';
  $map{'\\xC7\\xB6'}='&#x1F6;';
  $map{'\\xC7\\xB7'}='&#x1F7;';
  $map{'\\xC7\\xB8'}='&#x1F8;';
  $map{'\\xC7\\xB9'}='&#x1F9;';
  $map{'\\xC7\\xBA'}='&#x1FA;';
  $map{'\\xC7\\xBB'}='&#x1FB;';
  $map{'\\xC7\\xBC'}='&#x1FC;';
  $map{'\\xC7\\xBD'}='&#x1FD;';
  $map{'\\xC7\\xBE'}='&#x1FE;';
  $map{'\\xC7\\xBF'}='&#x1FF;';
  $map{'\\xC8\\x80'}='&#x200;';
  $map{'\\xC8\\x81'}='&#x201;';
  $map{'\\xC8\\x82'}='&#x202;';
  $map{'\\xC8\\x83'}='&#x203;';
  $map{'\\xC8\\x84'}='&#x204;';
  $map{'\\xC8\\x85'}='&#x205;';
  $map{'\\xC8\\x86'}='&#x206;';
  $map{'\\xC8\\x87'}='&#x207;';
  $map{'\\xC8\\x88'}='&#x208;';
  $map{'\\xC8\\x89'}='&#x209;';
  $map{'\\xC8\\x8a'}='&#x20A;';
  $map{'\\xC8\\x8b'}='&#x20B;';
  $map{'\\xC8\\x8c'}='&#x20C;';
  $map{'\\xC8\\x8d'}='&#x20D;';
  $map{'\\xC8\\x8e'}='&#x20E;';
  $map{'\\xC8\\x8f'}='&#x20F;';
  $map{'\\xC8\\x90'}='&#x210;';
  $map{'\\xC8\\x91'}='&#x211;';
  $map{'\\xC8\\x92'}='&#x212;';
  $map{'\\xC8\\x93'}='&#x213;';
  $map{'\\xC8\\x94'}='&#x214;';
  $map{'\\xC8\\x95'}='&#x215;';
  $map{'\\xC8\\x96'}='&#x216;';
  $map{'\\xC8\\x97'}='&#x217;';
  $map{'\\xC8\\x98'}='&#x218;';
  $map{'\\xC8\\x99'}='&#x219;';
  $map{'\\xC8\\x9A'}='&#x21A;';
  $map{'\\xC8\\x9B'}='&#x21B;';
  $map{'\\xC8\\x9C'}='&#x21C;';
  $map{'\\xC8\\x9D'}='&#x21D;';
  $map{'\\xC8\\x9E'}='&#x21E;';
  $map{'\\xC8\\x9F'}='&#x21F;';
  $map{'\\xC8\\xA0'}='&#x220;';
  $map{'\\xC8\\xA1'}='&#x221;';
  $map{'\\xC8\\xA2'}='&#x222;';
  $map{'\\xC8\\xA3'}='&#x223;';
  $map{'\\xC8\\xA4'}='&#x224;';
  $map{'\\xC8\\xA5'}='&#x225;';
  $map{'\\xC8\\xA6'}='&#x226;';
  $map{'\\xC8\\xA7'}='&#x227;';
  $map{'\\xC8\\xA8'}='&#x228;';
  $map{'\\xC8\\xA9'}='&#x229;';
  $map{'\\xC8\\xAA'}='&#x22A;';
  $map{'\\xC8\\xAB'}='&#x22B;';
  $map{'\\xC8\\xAC'}='&#x22C;';
  $map{'\\xC8\\xAD'}='&#x22D;';
  $map{'\\xC8\\xAE'}='&#x22E;';
  $map{'\\xC8\\xAF'}='&#x22F;';
  $map{'\\xC8\\xB0'}='&#x230;';
  $map{'\\xC8\\xB1'}='&#x231;';
  $map{'\\xC8\\xB2'}='&#x232;';
  $map{'\\xC8\\xB3'}='&#x233;';
  $map{'\\xC8\\xB4'}='&#x234;';
  $map{'\\xC8\\xB5'}='&#x235;';
  $map{'\\xC8\\xB6'}='&#x236;';
  $map{'\\xC8\\xB7'}='&#x237;';
  $map{'\\xC8\\xB8'}='&#x238;';
  $map{'\\xC8\\xB9'}='&#x239;';
  $map{'\\xC8\\xBA'}='&#x23A;';
  $map{'\\xC8\\xBB'}='&#x23B;';
  $map{'\\xC8\\xBC'}='&#x23C;';
  $map{'\\xC8\\xBD'}='&#x23D;';
  $map{'\\xC8\\xBE'}='&#x23E;';
  $map{'\\xC8\\xBF'}='&#x23F;';
  $map{'\\xC9\\x80'}='&#x240;';
  $map{'\\xC9\\x81'}='&#x241;';
  $map{'\\xC9\\x82'}='&#x242;';
  $map{'\\xC9\\x83'}='&#x243;';
  $map{'\\xC9\\x84'}='&#x244;';
  $map{'\\xC9\\x85'}='&#x245;';
  $map{'\\xC9\\x86'}='&#x246;';
  $map{'\\xC9\\x87'}='&#x247;';
  $map{'\\xC9\\x88'}='&#x248;';
  $map{'\\xC9\\x89'}='&#x249;';
  $map{'\\xC9\\x8A'}='&#x24A;';
  $map{'\\xC9\\x8B'}='&#x24B;';
  $map{'\\xC9\\x8C'}='&#x24C;';
  $map{'\\xC9\\x8D'}='&#x24D;';
  $map{'\\xC9\\x8E'}='&#x24E;';
  $map{'\\xC9\\x8F'}='&#x24F;';
  $map{'\\xC9\\x90'}='&#x250;';
  $map{'\\xC9\\x91'}='&#x251;';
  $map{'\\xC9\\x92'}='&#x252;';
  $map{'\\xC9\\x93'}='&#x253;';
  $map{'\\xC9\\x94'}='&#x254;';
  $map{'\\xC9\\x95'}='&#x255;';
  $map{'\\xC9\\x96'}='&#x256;';
  $map{'\\xC9\\x97'}='&#x257;';
  $map{'\\xC9\\x98'}='&#x258;';
  $map{'\\xC9\\x99'}='&#x259;';
  $map{'\\xC9\\x9A'}='&#x25A;';
  $map{'\\xC9\\x9B'}='&#x25B;';
  $map{'\\xC9\\x9C'}='&#x25C;';
  $map{'\\xC9\\x9D'}='&#x25D;';
  $map{'\\xC9\\x9E'}='&#x25E;';
  $map{'\\xC9\\x9F'}='&#x25F;';
  $map{'\\xC9\\xA0'}='&#x260;';
  $map{'\\xC9\\xA1'}='&#x261;';
  $map{'\\xC9\\xA2'}='&#x262;';
  $map{'\\xC9\\xA3'}='&#x263;';
  $map{'\\xC9\\xA4'}='&#x264;';
  $map{'\\xC9\\xA5'}='&#x265;';
  $map{'\\xC9\\xA6'}='&#x266;';
  $map{'\\xC9\\xA7'}='&#x267;';
  $map{'\\xC9\\xA8'}='&#x268;';
  $map{'\\xC9\\xA9'}='&#x269;';
  $map{'\\xC9\\xAA'}='&#x26A;';
  $map{'\\xC9\\xAB'}='&#x26B;';
  $map{'\\xC9\\xAC'}='&#x26C;';
  $map{'\\xC9\\xAD'}='&#x26D;';
  $map{'\\xC9\\xAE'}='&#x26E;';
  $map{'\\xC9\\xAF'}='&#x26F;';
  $map{'\\xC9\\xB0'}='&#x270;';
  $map{'\\xC9\\xB1'}='&#x271;';
  $map{'\\xC9\\xB2'}='&#x272;';
  $map{'\\xC9\\xB3'}='&#x273;';
  $map{'\\xC9\\xB4'}='&#x274;';
  $map{'\\xC9\\xB5'}='&#x275;';
  $map{'\\xC9\\xB6'}='&#x276;';
  $map{'\\xC9\\xB7'}='&#x277;';
  $map{'\\xC9\\xB8'}='&#x278;';
  $map{'\\xC9\\xB9'}='&#x279;';
  $map{'\\xC9\\xBA'}='&#x27A;';
  $map{'\\xC9\\xBB'}='&#x27B;';
  $map{'\\xC9\\xBC'}='&#x27C;';
  $map{'\\xC9\\xBD'}='&#x27D;';
  $map{'\\xC9\\xBE'}='&#x27E;';
  $map{'\\xC9\\xBF'}='&#x27F;';
  $map{'\\xCA\\x80'}='&#x280;';
  $map{'\\xCA\\x81'}='&#x281;';
  $map{'\\xCA\\x82'}='&#x282;';
  $map{'\\xCA\\x83'}='&#x283;';
  $map{'\\xCA\\x84'}='&#x284;';
  $map{'\\xCA\\x85'}='&#x285;';
  $map{'\\xCA\\x86'}='&#x286;';
  $map{'\\xCA\\x87'}='&#x287;';
  $map{'\\xCA\\x88'}='&#x288;';
  $map{'\\xCA\\x89'}='&#x289;';
  $map{'\\xCA\\x8A'}='&#x28A;';
  $map{'\\xCA\\x8B'}='&#x28B;';
  $map{'\\xCA\\x8C'}='&#x28C;';
  $map{'\\xCA\\x8D'}='&#x28D;';
  $map{'\\xCA\\x8E'}='&#x28E;';
  $map{'\\xCA\\x8F'}='&#x28F;';
  $map{'\\xCA\\x90'}='&#x290;';
  $map{'\\xCA\\x91'}='&#x291;';
  $map{'\\xCA\\x92'}='&#x292;';
  $map{'\\xCA\\x93'}='&#x293;';
  $map{'\\xCA\\x94'}='&#x294;';
  $map{'\\xCA\\x95'}='&#x295;';
  $map{'\\xCA\\x96'}='&#x296;';
  $map{'\\xCA\\x97'}='&#x297;';
  $map{'\\xCA\\x98'}='&#x298;';
  $map{'\\xCA\\x99'}='&#x299;';
  $map{'\\xCA\\x9A'}='&#x29A;';
  $map{'\\xCA\\x9B'}='&#x29B;';
  $map{'\\xCA\\x9C'}='&#x29C;';
  $map{'\\xCA\\x9D'}='&#x29D;';
  $map{'\\xCA\\x9E'}='&#x29E;';
  $map{'\\xCA\\x9F'}='&#x29F;';
  $map{'\\xCA\\xA0'}='&#x2A0;';
  $map{'\\xCA\\xA1'}='&#x2A1;';
  $map{'\\xCA\\xA2'}='&#x2A2;';
  $map{'\\xCA\\xA3'}='&#x2A3;';
  $map{'\\xCA\\xA4'}='&#x2A4;';
  $map{'\\xCA\\xA5'}='&#x2A5;';
  $map{'\\xCA\\xA6'}='&#x2A6;';
  $map{'\\xCA\\xA7'}='&#x2A7;';
  $map{'\\xCA\\xA8'}='&#x2A8;';
  $map{'\\xCA\\xA9'}='&#x2A9;';
  $map{'\\xCA\\xAA'}='&#x2AA;';
  $map{'\\xCA\\xAB'}='&#x2AB;';
  $map{'\\xCA\\xAC'}='&#x2AC;';
  $map{'\\xCA\\xAD'}='&#x2AD;';
  $map{'\\xCA\\xAE'}='&#x2AE;';
  $map{'\\xCA\\xAF'}='&#x2AF;';
  $map{'\\xCA\\xB0'}='&#x2B0;';
  $map{'\\xCA\\xB1'}='&#x2B1;';
  $map{'\\xCA\\xB2'}='&#x2B2;';
  $map{'\\xCA\\xB3'}='&#x2B3;';
  $map{'\\xCA\\xB4'}='&#x2B4;';
  $map{'\\xCA\\xB5'}='&#x2B5;';
  $map{'\\xCA\\xB6'}='&#x2B6;';
  $map{'\\xCA\\xB7'}='&#x2B7;';
  $map{'\\xCA\\xB8'}='&#x2B8;';
  $map{'\\xCA\\xB9'}='&#x2B9;';
  $map{'\\xCA\\xBA'}='&#x2BA;';
  $map{'\\xCA\\xBB'}='&#x2BB;';
  $map{'\\xCA\\xBC'}='&#x2BC;';
  $map{'\\xCA\\xBD'}='&#x2BD;';
  $map{'\\xCA\\xBE'}='&#x2BE;';
  $map{'\\xCA\\xBF'}='&#x2BF;';
  $map{'\\xCB\\x80'}='&#x2C0;';
  $map{'\\xCB\\x81'}='&#x2C1;';
  $map{'\\xCB\\x82'}='&#x2C2;';
  $map{'\\xCB\\x83'}='&#x2C3;';
  $map{'\\xCB\\x84'}='&#x2C4;';
  $map{'\\xCB\\x85'}='&#x2C5;';
  $map{'\\xCB\\x86'}='&#x2C6;';
  $map{'\\xCB\\x87'}='&#x2C7;';
  $map{'\\xCB\\x88'}='&#x2C8;';
  $map{'\\xCB\\x89'}='&#x2C9;';
  $map{'\\xCB\\x8A'}='&#x2CA;';
  $map{'\\xCB\\x8B'}='&#x2CB;';
  $map{'\\xCB\\x8C'}='&#x2CC;';
  $map{'\\xCB\\x8D'}='&#x2CD;';
  $map{'\\xCB\\x8E'}='&#x2CE;';
  $map{'\\xCB\\x8F'}='&#x2CF;';
  $map{'\\xCB\\x90'}='&#x2D0;';
  $map{'\\xCB\\x91'}='&#x2D1;';
  $map{'\\xCB\\x92'}='&#x2D2;';
  $map{'\\xCB\\x93'}='&#x2D3;';
  $map{'\\xCB\\x94'}='&#x2D4;';
  $map{'\\xCB\\x95'}='&#x2D5;';
  $map{'\\xCB\\x96'}='&#x2D6;';
  $map{'\\xCB\\x97'}='&#x2D7;';
  $map{'\\xCB\\x98'}='&#x2D8;';
  $map{'\\xCB\\x99'}='&#x2D9;';
  $map{'\\xCB\\x9A'}='&#x2DA;';
  $map{'\\xCB\\x9B'}='&#x2DB;';
  $map{'\\xCB\\x9C'}='&#x2DC;';
  $map{'\\xCB\\x9D'}='&#x2DD;';
  $map{'\\xCB\\x9E'}='&#x2DE;';
  $map{'\\xCB\\x9F'}='&#x2DF;';
  $map{'\\xCB\\xA0'}='&#x2E0;';
  $map{'\\xCB\\xA1'}='&#x2E1;';
  $map{'\\xCB\\xA2'}='&#x2E2;';
  $map{'\\xCB\\xA3'}='&#x2E3;';
  $map{'\\xCB\\xA4'}='&#x2E4;';
  $map{'\\xCB\\xA5'}='&#x2E5;';
  $map{'\\xCB\\xA6'}='&#x2E6;';
  $map{'\\xCB\\xA7'}='&#x2E7;';
  $map{'\\xCB\\xA8'}='&#x2E8;';
  $map{'\\xCB\\xA9'}='&#x2E9;';
  $map{'\\xCB\\xAA'}='&#x2EA;';
  $map{'\\xCB\\xAB'}='&#x2EB;';
  $map{'\\xCB\\xAC'}='&#x2EC;';
  $map{'\\xCB\\xAD'}='&#x2ED;';
  $map{'\\xCB\\xAE'}='&#x2EE;';
  $map{'\\xCB\\xAF'}='&#x2EF;';
  $map{'\\xCB\\xB0'}='&#x2F0;';
  $map{'\\xCB\\xB1'}='&#x2F1;';
  $map{'\\xCB\\xB2'}='&#x2F2;';
  $map{'\\xCB\\xB3'}='&#x2F3;';
  $map{'\\xCB\\xB4'}='&#x2F4;';
  $map{'\\xCB\\xB5'}='&#x2F5;';
  $map{'\\xCB\\xB6'}='&#x2F6;';
  $map{'\\xCB\\xB7'}='&#x2F7;';
  $map{'\\xCB\\xB8'}='&#x2F8;';
  $map{'\\xCB\\xB9'}='&#x2F9;';
  $map{'\\xCB\\xBA'}='&#x2FA;';
  $map{'\\xCB\\xBB'}='&#x2FB;';
  $map{'\\xCB\\xBC'}='&#x2FC;';
  $map{'\\xCB\\xBD'}='&#x2FD;';
  $map{'\\xCB\\xBE'}='&#x2FE;';
  $map{'\\xCB\\xBF'}='&#x2FF;';
  $map{'\\xCC\\x80'}='&#x300;';
  $map{'\\xCC\\x81'}='&#x301;';
  $map{'\\xCC\\x82'}='&#x302;';
  $map{'\\xCC\\x83'}='&#x303;';
  $map{'\\xCC\\x84'}='&#x304;';
  $map{'\\xCC\\x85'}='&#x305;';
  $map{'\\xCC\\x86'}='&#x306;';
  $map{'\\xCC\\x87'}='&#x307;';
  $map{'\\xCC\\x88'}='&#x308;';
  $map{'\\xCC\\x89'}='&#x309;';
  $map{'\\xCC\\x8A'}='&#x30A;';
  $map{'\\xCC\\x8B'}='&#x30B;';
  $map{'\\xCC\\x8C'}='&#x30C;';
  $map{'\\xCC\\x8D'}='&#x30D;';
  $map{'\\xCC\\x8E'}='&#x30E;';
  $map{'\\xCC\\x8F'}='&#x30F;';
  $map{'\\xCC\\x90'}='&#x310;';
  $map{'\\xCC\\x91'}='&#x311;';
  $map{'\\xCC\\x92'}='&#x312;';
  $map{'\\xCC\\x93'}='&#x313;';
  $map{'\\xCC\\x94'}='&#x314;';
  $map{'\\xCC\\x95'}='&#x315;';
  $map{'\\xCC\\x96'}='&#x316;';
  $map{'\\xCC\\x97'}='&#x317;';
  $map{'\\xCC\\x98'}='&#x318;';
  $map{'\\xCC\\x99'}='&#x319;';
  $map{'\\xCC\\x9A'}='&#x31A;';
  $map{'\\xCC\\x9B'}='&#x31B;';
  $map{'\\xCC\\x9C'}='&#x31C;';
  $map{'\\xCC\\x9D'}='&#x31D;';
  $map{'\\xCC\\x9E'}='&#x31E;';
  $map{'\\xCC\\x9F'}='&#x31F;';
  $map{'\\xCC\\xA0'}='&#x320;';
  $map{'\\xCC\\xA1'}='&#x321;';
  $map{'\\xCC\\xA2'}='&#x322;';
  $map{'\\xCC\\xA3'}='&#x323;';
  $map{'\\xCC\\xA4'}='&#x324;';
  $map{'\\xCC\\xA5'}='&#x325;';
  $map{'\\xCC\\xA6'}='&#x326;';
  $map{'\\xCC\\xA7'}='&#x327;';
  $map{'\\xCC\\xA8'}='&#x328;';
  $map{'\\xCC\\xA9'}='&#x329;';
  $map{'\\xCC\\xAA'}='&#x32A;';
  $map{'\\xCC\\xAB'}='&#x32B;';
  $map{'\\xCC\\xAC'}='&#x32C;';
  $map{'\\xCC\\xAD'}='&#x32D;';
  $map{'\\xCC\\xAE'}='&#x32E;';
  $map{'\\xCC\\xAF'}='&#x32F;';
  $map{'\\xCC\\xB0'}='&#x330;';
  $map{'\\xCC\\xB1'}='&#x331;';
  $map{'\\xCC\\xB2'}='&#x332;';
  $map{'\\xCC\\xB3'}='&#x333;';
  $map{'\\xCC\\xB4'}='&#x334;';
  $map{'\\xCC\\xB5'}='&#x335;';
  $map{'\\xCC\\xB6'}='&#x336;';
  $map{'\\xCC\\xB7'}='&#x337;';
  $map{'\\xCC\\xB8'}='&#x338;';
  $map{'\\xCC\\xB9'}='&#x339;';
  $map{'\\xCC\\xBA'}='&#x33A;';
  $map{'\\xCC\\xBB'}='&#x33B;';
  $map{'\\xCC\\xBC'}='&#x33C;';
  $map{'\\xCC\\xBD'}='&#x33D;';
  $map{'\\xCC\\xBE'}='&#x33E;';
  $map{'\\xCC\\xBF'}='&#x33F;';
  $map{'\\xCD\\x80'}='&#x340;';
  $map{'\\xCD\\x81'}='&#x341;';
  $map{'\\xCD\\x82'}='&#x342;';
  $map{'\\xCD\\x83'}='&#x343;';
  $map{'\\xCD\\x84'}='&#x344;';
  $map{'\\xCD\\x85'}='&#x345;';
  $map{'\\xCD\\x86'}='&#x346;';
  $map{'\\xCD\\x87'}='&#x347;';
  $map{'\\xCD\\x88'}='&#x348;';
  $map{'\\xCD\\x89'}='&#x349;';
  $map{'\\xCD\\x8A'}='&#x34A;';
  $map{'\\xCD\\x8B'}='&#x34B;';
  $map{'\\xCD\\x8C'}='&#x34C;';
  $map{'\\xCD\\x8D'}='&#x34D;';
  $map{'\\xCD\\x8E'}='&#x34E;';
  $map{'\\xCD\\x8F'}='&#x34F;';
  $map{'\\xCD\\x90'}='&#x350;';
  $map{'\\xCD\\x91'}='&#x351;';
  $map{'\\xCD\\x92'}='&#x352;';
  $map{'\\xCD\\x93'}='&#x353;';
  $map{'\\xCD\\x94'}='&#x354;';
  $map{'\\xCD\\x95'}='&#x355;';
  $map{'\\xCD\\x96'}='&#x356;';
  $map{'\\xCD\\x97'}='&#x357;';
  $map{'\\xCD\\x98'}='&#x358;';
  $map{'\\xCD\\x99'}='&#x359;';
  $map{'\\xCD\\x9A'}='&#x35A;';
  $map{'\\xCD\\x9B'}='&#x35B;';
  $map{'\\xCD\\x9C'}='&#x35C;';
  $map{'\\xCD\\x9D'}='&#x35D;';
  $map{'\\xCD\\x9E'}='&#x35E;';
  $map{'\\xCD\\x9F'}='&#x35F;';
  $map{'\\xCD\\xA0'}='&#x360;';
  $map{'\\xCD\\xA1'}='&#x361;';
  $map{'\\xCD\\xA2'}='&#x362;';
  $map{'\\xCD\\xA3'}='&#x363;';
  $map{'\\xCD\\xA4'}='&#x364;';
  $map{'\\xCD\\xA5'}='&#x365;';
  $map{'\\xCD\\xA6'}='&#x366;';
  $map{'\\xCD\\xA7'}='&#x367;';
  $map{'\\xCD\\xA8'}='&#x368;';
  $map{'\\xCD\\xA9'}='&#x369;';
  $map{'\\xCD\\xAA'}='&#x36A;';
  $map{'\\xCD\\xAB'}='&#x36B;';
  $map{'\\xCD\\xAC'}='&#x36C;';
  $map{'\\xCD\\xAD'}='&#x36D;';
  $map{'\\xCD\\xAE'}='&#x36E;';
  $map{'\\xCD\\xAF'}='&#x36F;';
  $map{'\\xCD\\xB0'}='&#x370;';
  $map{'\\xCD\\xB1'}='&#x371;';
  $map{'\\xCD\\xB2'}='&#x372;';
  $map{'\\xCD\\xB3'}='&#x373;';
  $map{'\\xCD\\xB4'}='&#x374;';
  $map{'\\xCD\\xB5'}='&#x375;';
  $map{'\\xCD\\xB6'}='&#x376;';
  $map{'\\xCD\\xB7'}='&#x377;';
  $map{'\\xCD\\xB8'}='&#x378;';
  $map{'\\xCD\\xB9'}='&#x379;';
  $map{'\\xCD\\xBA'}='&#x37A;';
  $map{'\\xCD\\xBB'}='&#x37B;';
  $map{'\\xCD\\xBC'}='&#x37C;';
  $map{'\\xCD\\xBD'}='&#x37D;';
  $map{'\\xCD\\xBE'}='&#x37E;';
  $map{'\\xCD\\xBF'}='&#x37F;';
  $map{'\\xCE\\x80'}='&#x380;';
  $map{'\\xCE\\x81'}='&#x381;';
  $map{'\\xCE\\x82'}='&#x382;';
  $map{'\\xCE\\x83'}='&#x383;';
  $map{'\\xCE\\x84'}='&#x384;';
  $map{'\\xCE\\x85'}='&#x385;';
  $map{'\\xCE\\x86'}='&#x386;';
  $map{'\\xCE\\x87'}='&#x387;';
  $map{'\\xCE\\x88'}='&#x388;';
  $map{'\\xCE\\x89'}='&#x389;';
  $map{'\\xCE\\x8A'}='&#x38A;';
  $map{'\\xCE\\x8B'}='&#x38B;';
  $map{'\\xCE\\x8C'}='&#x38C;';
  $map{'\\xCE\\x8D'}='&#x38D;';
  $map{'\\xCE\\x8E'}='&#x38E;';
  $map{'\\xCE\\x8F'}='&#x38F;';
  $map{'\\xCE\\x90'}='&#x390;';
  $map{'\\xCE\\x91'}='&#x391;';
  $map{'\\xCE\\x92'}='&#x392;';
  $map{'\\xCE\\x93'}='&#x393;';
  $map{'\\xCE\\x94'}='&#x394;';
  $map{'\\xCE\\x95'}='&#x395;';
  $map{'\\xCE\\x96'}='&#x396;';
  $map{'\\xCE\\x97'}='&#x397;';
  $map{'\\xCE\\x98'}='&#x398;';
  $map{'\\xCE\\x99'}='&#x399;';
  $map{'\\xCE\\x9A'}='&#x39A;';
  $map{'\\xCE\\x9B'}='&#x39B;';
  $map{'\\xCE\\x9C'}='&#x39C;';
  $map{'\\xCE\\x9D'}='&#x39D;';
  $map{'\\xCE\\x9E'}='&#x39E;';
  $map{'\\xCE\\x9F'}='&#x39F;';
  $map{'\\xCE\\xA0'}='&#x3A0;';
  $map{'\\xCE\\xA1'}='&#x3A1;';
  $map{'\\xCE\\xA2'}='&#x3A2;';
  $map{'\\xCE\\xA3'}='&#x3A3;';
  $map{'\\xCE\\xA4'}='&#x3A4;';
  $map{'\\xCE\\xA5'}='&#x3A5;';
  $map{'\\xCE\\xA6'}='&#x3A6;';
  $map{'\\xCE\\xA7'}='&#x3A7;';
  $map{'\\xCE\\xA8'}='&#x3A8;';
  $map{'\\xCE\\xA9'}='&#x3A9;';
  $map{'\\xCE\\xAA'}='&#x3AA;';
  $map{'\\xCE\\xAB'}='&#x3AB;';
  $map{'\\xCE\\xAC'}='&#x3AC;';
  $map{'\\xCE\\xAD'}='&#x3AD;';
  $map{'\\xCE\\xAE'}='&#x3AE;';
  $map{'\\xCE\\xAF'}='&#x3AF;';
  $map{'\\xCE\\xB0'}='&#x3B0;';
  $map{'\\xCE\\xB1'}='&#x3B1;';
  $map{'\\xCE\\xB2'}='&#x3B2;';
  $map{'\\xCE\\xB3'}='&#x3B3;';
  $map{'\\xCE\\xB4'}='&#x3B4;';
  $map{'\\xCE\\xB5'}='&#x3B5;';
  $map{'\\xCE\\xB6'}='&#x3B6;';
  $map{'\\xCE\\xB7'}='&#x3B7;';
  $map{'\\xCE\\xB8'}='&#x3B8;';
  $map{'\\xCE\\xB9'}='&#x3B9;';
  $map{'\\xCE\\xBA'}='&#x3BA;';
  $map{'\\xCE\\xBB'}='&#x3BB;';
  $map{'\\xCE\\xBC'}='&#x3BC;';
  $map{'\\xCE\\xBD'}='&#x3BD;';
  $map{'\\xCE\\xBE'}='&#x3BE;';
  $map{'\\xCE\\xBF'}='&#x3BF;';
  $map{'\\xCF\\x80'}='&#x3C0;';
  $map{'\\xCF\\x81'}='&#x3C1;';
  $map{'\\xCF\\x82'}='&#x3C2;';
  $map{'\\xCF\\x83'}='&#x3C3;';
  $map{'\\xCF\\x84'}='&#x3C4;';
  $map{'\\xCF\\x85'}='&#x3C5;';
  $map{'\\xCF\\x86'}='&#x3C6;';
  $map{'\\xCF\\x87'}='&#x3C7;';
  $map{'\\xCF\\x88'}='&#x3C8;';
  $map{'\\xCF\\x89'}='&#x3C9;';
  $map{'\\xCF\\x8A'}='&#x3CA;';
  $map{'\\xCF\\x8B'}='&#x3CB;';
  $map{'\\xCF\\x8C'}='&#x3CC;';
  $map{'\\xCF\\x8D'}='&#x3CD;';
  $map{'\\xCF\\x8E'}='&#x3CE;';
  $map{'\\xCF\\x8F'}='&#x3CF;';
  $map{'\\xCF\\x90'}='&#x3D0;';
  $map{'\\xCF\\x91'}='&#x3D1;';
  $map{'\\xCF\\x92'}='&#x3D2;';
  $map{'\\xCF\\x93'}='&#x3D3;';
  $map{'\\xCF\\x94'}='&#x3D4;';
  $map{'\\xCF\\x95'}='&#x3D5;';
  $map{'\\xCF\\x96'}='&#x3D6;';
  $map{'\\xCF\\x97'}='&#x3D7;';
  $map{'\\xCF\\x98'}='&#x3D8;';
  $map{'\\xCF\\x99'}='&#x3D9;';
  $map{'\\xCF\\x9A'}='&#x3DA;';
  $map{'\\xCF\\x9B'}='&#x3DB;';
  $map{'\\xCF\\x9C'}='&#x3DC;';
  $map{'\\xCF\\x9D'}='&#x3DD;';
  $map{'\\xCF\\x9E'}='&#x3DE;';
  $map{'\\xCF\\x9F'}='&#x3DF;';
  $map{'\\xCF\\xA0'}='&#x3E0;';
  $map{'\\xCF\\xA1'}='&#x3E1;';
  $map{'\\xCF\\xA2'}='&#x3E2;';
  $map{'\\xCF\\xA3'}='&#x3E3;';
  $map{'\\xCF\\xA4'}='&#x3E4;';
  $map{'\\xCF\\xA5'}='&#x3E5;';
  $map{'\\xCF\\xA6'}='&#x3E6;';
  $map{'\\xCF\\xA7'}='&#x3E7;';
  $map{'\\xCF\\xA8'}='&#x3E8;';
  $map{'\\xCF\\xA9'}='&#x3E9;';
  $map{'\\xCF\\xAA'}='&#x3EA;';
  $map{'\\xCF\\xAB'}='&#x3EB;';
  $map{'\\xCF\\xAC'}='&#x3EC;';
  $map{'\\xCF\\xAD'}='&#x3ED;';
  $map{'\\xCF\\xAE'}='&#x3EE;';
  $map{'\\xCF\\xAF'}='&#x3EF;';
  $map{'\\xCF\\xB0'}='&#x3F0;';
  $map{'\\xCF\\xB1'}='&#x3F1;';
  $map{'\\xCF\\xB2'}='&#x3F2;';
  $map{'\\xCF\\xB3'}='&#x3F3;';
  $map{'\\xCF\\xB4'}='&#x3F4;';
  $map{'\\xCF\\xB5'}='&#x3F5;';
  $map{'\\xCF\\xB6'}='&#x3F6;';
  $map{'\\xCF\\xB7'}='&#x3F7;';
  $map{'\\xCF\\xB8'}='&#x3F8;';
  $map{'\\xCF\\xB9'}='&#x3F9;';
  $map{'\\xCF\\xBA'}='&#x3FA;';
  $map{'\\xCF\\xBB'}='&#x3FB;';
  $map{'\\xCF\\xBC'}='&#x3FC;';
  $map{'\\xCF\\xBD'}='&#x3FD;';
  $map{'\\xCF\\xBE'}='&#x3FE;';
  $map{'\\xCF\\xBF'}='&#x3FF;';
  $map{'\\xD0\\x80'}='&#x400;';
  $map{'\\xD0\\x81'}='&#x401;';
  $map{'\\xD0\\x82'}='&#x402;';
  $map{'\\xD0\\x83'}='&#x403;';
  $map{'\\xD0\\x84'}='&#x404;';
  $map{'\\xD0\\x85'}='&#x405;';
  $map{'\\xD0\\x86'}='&#x406;';
  $map{'\\xD0\\x87'}='&#x407;';
  $map{'\\xD0\\x88'}='&#x408;';
  $map{'\\xD0\\x89'}='&#x409;';
  $map{'\\xD0\\x8A'}='&#x40A;';
  $map{'\\xD0\\x8B'}='&#x40B;';
  $map{'\\xD0\\x8C'}='&#x40C;';
  $map{'\\xD0\\x8D'}='&#x40D;';
  $map{'\\xD0\\x8E'}='&#x40E;';
  $map{'\\xD0\\x8F'}='&#x40F;';
  $map{'\\xD0\\x90'}='&#x410;';
  $map{'\\xD0\\x91'}='&#x411;';
  $map{'\\xD0\\x92'}='&#x412;';
  $map{'\\xD0\\x93'}='&#x413;';
  $map{'\\xD0\\x94'}='&#x414;';
  $map{'\\xD0\\x95'}='&#x415;';
  $map{'\\xD0\\x96'}='&#x416;';
  $map{'\\xD0\\x97'}='&#x417;';
  $map{'\\xD0\\x98'}='&#x418;';
  $map{'\\xD0\\x99'}='&#x419;';
  $map{'\\xD0\\x9A'}='&#x41A;';
  $map{'\\xD0\\x9B'}='&#x41B;';
  $map{'\\xD0\\x9C'}='&#x41C;';
  $map{'\\xD0\\x9D'}='&#x41D;';
  $map{'\\xD0\\x9E'}='&#x41E;';
  $map{'\\xD0\\x9F'}='&#x41F;';
  $map{'\\xD0\\xA0'}='&#x420;';
  $map{'\\xD0\\xA1'}='&#x421;';
  $map{'\\xD0\\xA2'}='&#x422;';
  $map{'\\xD0\\xA3'}='&#x423;';
  $map{'\\xD0\\xA4'}='&#x424;';
  $map{'\\xD0\\xA5'}='&#x425;';
  $map{'\\xD0\\xA6'}='&#x426;';
  $map{'\\xD0\\xA7'}='&#x427;';
  $map{'\\xD0\\xA8'}='&#x428;';
  $map{'\\xD0\\xA9'}='&#x429;';
  $map{'\\xD0\\xAA'}='&#x42A;';
  $map{'\\xD0\\xAB'}='&#x42B;';
  $map{'\\xD0\\xAC'}='&#x42C;';
  $map{'\\xD0\\xAD'}='&#x42D;';
  $map{'\\xD0\\xAE'}='&#x42E;';
  $map{'\\xD0\\xAF'}='&#x42F;';
  $map{'\\xD0\\xB0'}='&#x430;';
  $map{'\\xD0\\xB1'}='&#x431;';
  $map{'\\xD0\\xB2'}='&#x432;';
  $map{'\\xD0\\xB3'}='&#x433;';
  $map{'\\xD0\\xB4'}='&#x434;';
  $map{'\\xD0\\xB5'}='&#x435;';
  $map{'\\xD0\\xB6'}='&#x436;';
  $map{'\\xD0\\xB7'}='&#x437;';
  $map{'\\xD0\\xB8'}='&#x438;';
  $map{'\\xD0\\xB9'}='&#x439;';
  $map{'\\xD0\\xBA'}='&#x43A;';
  $map{'\\xD0\\xBB'}='&#x43B;';
  $map{'\\xD0\\xBC'}='&#x43C;';
  $map{'\\xD0\\xBD'}='&#x43D;';
  $map{'\\xD0\\xBE'}='&#x43E;';
  $map{'\\xD0\\xBF'}='&#x43F;';
  $map{'\\xD1\\x80'}='&#x440;';
  $map{'\\xD1\\x81'}='&#x441;';
  $map{'\\xD1\\x82'}='&#x442;';
  $map{'\\xD1\\x83'}='&#x443;';
  $map{'\\xD1\\x84'}='&#x444;';
  $map{'\\xD1\\x85'}='&#x445;';
  $map{'\\xD1\\x86'}='&#x446;';
  $map{'\\xD1\\x87'}='&#x447;';
  $map{'\\xD1\\x88'}='&#x448;';
  $map{'\\xD1\\x89'}='&#x449;';
  $map{'\\xD1\\x8A'}='&#x44A;';
  $map{'\\xD1\\x8B'}='&#x44B;';
  $map{'\\xD1\\x8C'}='&#x44C;';
  $map{'\\xD1\\x8D'}='&#x44D;';
  $map{'\\xD1\\x8E'}='&#x44E;';
  $map{'\\xD1\\x8F'}='&#x44F;';
  $map{'\\xD1\\x90'}='&#x450;';
  $map{'\\xD1\\x91'}='&#x451;';
  $map{'\\xD1\\x92'}='&#x452;';
  $map{'\\xD1\\x93'}='&#x453;';
  $map{'\\xD1\\x94'}='&#x454;';
  $map{'\\xD1\\x95'}='&#x455;';
  $map{'\\xD1\\x96'}='&#x456;';
  $map{'\\xD1\\x97'}='&#x457;';
  $map{'\\xD1\\x98'}='&#x458;';
  $map{'\\xD1\\x99'}='&#x459;';
  $map{'\\xD1\\x9A'}='&#x45A;';
  $map{'\\xD1\\x9B'}='&#x45B;';
  $map{'\\xD1\\x9C'}='&#x45C;';
  $map{'\\xD1\\x9D'}='&#x45D;';
  $map{'\\xD1\\x9E'}='&#x45E;';
  $map{'\\xD1\\x9F'}='&#x45F;';
  $map{'\\xD1\\xA0'}='&#x460;';
  $map{'\\xD1\\xA1'}='&#x461;';
  $map{'\\xD1\\xA2'}='&#x462;';
  $map{'\\xD1\\xA3'}='&#x463;';
  $map{'\\xD1\\xA4'}='&#x464;';
  $map{'\\xD1\\xA5'}='&#x465;';
  $map{'\\xD1\\xA6'}='&#x466;';
  $map{'\\xD1\\xA7'}='&#x467;';
  $map{'\\xD1\\xA8'}='&#x468;';
  $map{'\\xD1\\xA9'}='&#x469;';
  $map{'\\xD1\\xAA'}='&#x46A;';
  $map{'\\xD1\\xAB'}='&#x46B;';
  $map{'\\xD1\\xAC'}='&#x46C;';
  $map{'\\xD1\\xAD'}='&#x46D;';
  $map{'\\xD1\\xAE'}='&#x46E;';
  $map{'\\xD1\\xAF'}='&#x46F;';
  $map{'\\xD1\\xB0'}='&#x470;';
  $map{'\\xD1\\xB1'}='&#x471;';
  $map{'\\xD1\\xB2'}='&#x472;';
  $map{'\\xD1\\xB3'}='&#x473;';
  $map{'\\xD1\\xB4'}='&#x474;';
  $map{'\\xD1\\xB5'}='&#x475;';
  $map{'\\xD1\\xB6'}='&#x476;';
  $map{'\\xD1\\xB7'}='&#x477;';
  $map{'\\xD1\\xB8'}='&#x478;';
  $map{'\\xD1\\xB9'}='&#x479;';
  $map{'\\xD1\\xBA'}='&#x47A;';
  $map{'\\xD1\\xBB'}='&#x47B;';
  $map{'\\xD1\\xBC'}='&#x47C;';
  $map{'\\xD1\\xBD'}='&#x47D;';
  $map{'\\xD1\\xBE'}='&#x47E;';
  $map{'\\xD1\\xBF'}='&#x47F;';
  $map{'\\xD2\\x80'}='&#x480;';
  $map{'\\xD2\\x81'}='&#x481;';
  $map{'\\xD2\\x82'}='&#x482;';
  $map{'\\xD2\\x83'}='&#x483;';
  $map{'\\xD2\\x84'}='&#x484;';
  $map{'\\xD2\\x85'}='&#x485;';
  $map{'\\xD2\\x86'}='&#x486;';
  $map{'\\xD2\\x87'}='&#x487;';
  $map{'\\xD2\\x88'}='&#x488;';
  $map{'\\xD2\\x89'}='&#x489;';
  $map{'\\xD2\\x8A'}='&#x48A;';
  $map{'\\xD2\\x8B'}='&#x48B;';
  $map{'\\xD2\\x8C'}='&#x48C;';
  $map{'\\xD2\\x8D'}='&#x48D;';
  $map{'\\xD2\\x8E'}='&#x48E;';
  $map{'\\xD2\\x8F'}='&#x48F;';
  $map{'\\xD2\\x90'}='&#x490;';
  $map{'\\xD2\\x91'}='&#x491;';
  $map{'\\xD2\\x92'}='&#x492;';
  $map{'\\xD2\\x93'}='&#x493;';
  $map{'\\xD2\\x94'}='&#x494;';
  $map{'\\xD2\\x95'}='&#x495;';
  $map{'\\xD2\\x96'}='&#x496;';
  $map{'\\xD2\\x97'}='&#x497;';
  $map{'\\xD2\\x98'}='&#x498;';
  $map{'\\xD2\\x99'}='&#x499;';
  $map{'\\xD2\\x9A'}='&#x49A;';
  $map{'\\xD2\\x9B'}='&#x49B;';
  $map{'\\xD2\\x9C'}='&#x49C;';
  $map{'\\xD2\\x9D'}='&#x49D;';
  $map{'\\xD2\\x9E'}='&#x49E;';
  $map{'\\xD2\\x9F'}='&#x49F;';
  $map{'\\xD2\\xA0'}='&#x4A0;';
  $map{'\\xD2\\xA1'}='&#x4A1;';
  $map{'\\xD2\\xA2'}='&#x4A2;';
  $map{'\\xD2\\xA3'}='&#x4A3;';
  $map{'\\xD2\\xA4'}='&#x4A4;';
  $map{'\\xD2\\xA5'}='&#x4A5;';
  $map{'\\xD2\\xA6'}='&#x4A6;';
  $map{'\\xD2\\xA7'}='&#x4A7;';
  $map{'\\xD2\\xA8'}='&#x4A8;';
  $map{'\\xD2\\xA9'}='&#x4A9;';
  $map{'\\xD2\\xAA'}='&#x4AA;';
  $map{'\\xD2\\xAB'}='&#x4AB;';
  $map{'\\xD2\\xAC'}='&#x4AC;';
  $map{'\\xD2\\xAD'}='&#x4AD;';
  $map{'\\xD2\\xAE'}='&#x4AE;';
  $map{'\\xD2\\xAF'}='&#x4AF;';
  $map{'\\xD2\\xB0'}='&#x4B0;';
  $map{'\\xD2\\xB1'}='&#x4B1;';
  $map{'\\xD2\\xB2'}='&#x4B2;';
  $map{'\\xD2\\xB3'}='&#x4B3;';
  $map{'\\xD2\\xB4'}='&#x4B4;';
  $map{'\\xD2\\xB5'}='&#x4B5;';
  $map{'\\xD2\\xB6'}='&#x4B6;';
  $map{'\\xD2\\xB7'}='&#x4B7;';
  $map{'\\xD2\\xB8'}='&#x4B8;';
  $map{'\\xD2\\xB9'}='&#x4B9;';
  $map{'\\xD2\\xBA'}='&#x4BA;';
  $map{'\\xD2\\xBB'}='&#x4BB;';
  $map{'\\xD2\\xBC'}='&#x4BC;';
  $map{'\\xD2\\xBD'}='&#x4BD;';
  $map{'\\xD2\\xBE'}='&#x4BE;';
  $map{'\\xD2\\xBF'}='&#x4BF;';
  $map{'\\xD3\\x80'}='&#x4C0;';
  $map{'\\xD3\\x81'}='&#x4C1;';
  $map{'\\xD3\\x82'}='&#x4C2;';
  $map{'\\xD3\\x83'}='&#x4C3;';
  $map{'\\xD3\\x84'}='&#x4C4;';
  $map{'\\xD3\\x85'}='&#x4C5;';
  $map{'\\xD3\\x86'}='&#x4C6;';
  $map{'\\xD3\\x87'}='&#x4C7;';
  $map{'\\xD3\\x88'}='&#x4C8;';
  $map{'\\xD3\\x89'}='&#x4C9;';
  $map{'\\xD3\\x8A'}='&#x4CA;';
  $map{'\\xD3\\x8B'}='&#x4CB;';
  $map{'\\xD3\\x8C'}='&#x4CC;';
  $map{'\\xD3\\x8D'}='&#x4CD;';
  $map{'\\xD3\\x8E'}='&#x4CE;';
  $map{'\\xD3\\x8F'}='&#x4CF;';
  $map{'\\xD3\\x90'}='&#x4D0;';
  $map{'\\xD3\\x91'}='&#x4D1;';
  $map{'\\xD3\\x92'}='&#x4D2;';
  $map{'\\xD3\\x93'}='&#x4D3;';
  $map{'\\xD3\\x94'}='&#x4D4;';
  $map{'\\xD3\\x95'}='&#x4D5;';
  $map{'\\xD3\\x96'}='&#x4D6;';
  $map{'\\xD3\\x97'}='&#x4D7;';
  $map{'\\xD3\\x98'}='&#x4D8;';
  $map{'\\xD3\\x99'}='&#x4D9;';
  $map{'\\xD3\\x9A'}='&#x4DA;';
  $map{'\\xD3\\x9B'}='&#x4DB;';
  $map{'\\xD3\\x9C'}='&#x4DC;';
  $map{'\\xD3\\x9D'}='&#x4DD;';
  $map{'\\xD3\\x9E'}='&#x4DE;';
  $map{'\\xD3\\x9F'}='&#x4DF;';
  $map{'\\xD3\\xA0'}='&#x4E0;';
  $map{'\\xD3\\xA1'}='&#x4E1;';
  $map{'\\xD3\\xA2'}='&#x4E2;';
  $map{'\\xD3\\xA3'}='&#x4E3;';
  $map{'\\xD3\\xA4'}='&#x4E4;';
  $map{'\\xD3\\xA5'}='&#x4E5;';
  $map{'\\xD3\\xA6'}='&#x4E6;';
  $map{'\\xD3\\xA7'}='&#x4E7;';
  $map{'\\xD3\\xA8'}='&#x4E8;';
  $map{'\\xD3\\xA9'}='&#x4E9;';
  $map{'\\xD3\\xAA'}='&#x4EA;';
  $map{'\\xD3\\xAB'}='&#x4EB;';
  $map{'\\xD3\\xAC'}='&#x4EC;';
  $map{'\\xD3\\xAD'}='&#x4ED;';
  $map{'\\xD3\\xAE'}='&#x4EE;';
  $map{'\\xD3\\xAF'}='&#x4EF;';
  $map{'\\xD3\\xB0'}='&#x4F0;';
  $map{'\\xD3\\xB1'}='&#x4F1;';
  $map{'\\xD3\\xB2'}='&#x4F2;';
  $map{'\\xD3\\xB3'}='&#x4F3;';
  $map{'\\xD3\\xB4'}='&#x4F4;';
  $map{'\\xD3\\xB5'}='&#x4F5;';
  $map{'\\xD3\\xB6'}='&#x4F6;';
  $map{'\\xD3\\xB7'}='&#x4F7;';
  $map{'\\xD3\\xB8'}='&#x4F8;';
  $map{'\\xD3\\xB9'}='&#x4F9;';
  $map{'\\xD3\\xBA'}='&#x4FA;';
  $map{'\\xD3\\xBB'}='&#x4FB;';
  $map{'\\xD3\\xBC'}='&#x4FC;';
  $map{'\\xD3\\xBD'}='&#x4FD;';
  $map{'\\xD3\\xBE'}='&#x4FE;';
  $map{'\\xD3\\xBF'}='&#x4FF;';
  $map{'\\xD4\\x80'}='&#x500;';
  $map{'\\xD4\\x81'}='&#x501;';
  $map{'\\xD4\\x82'}='&#x502;';
  $map{'\\xD4\\x83'}='&#x503;';
  $map{'\\xD4\\x84'}='&#x504;';
  $map{'\\xD4\\x85'}='&#x505;';
  $map{'\\xD4\\x86'}='&#x506;';
  $map{'\\xD4\\x87'}='&#x507;';
  $map{'\\xD4\\x88'}='&#x508;';
  $map{'\\xD4\\x89'}='&#x509;';
  $map{'\\xD4\\x8A'}='&#x50A;';
  $map{'\\xD4\\x8B'}='&#x50B;';
  $map{'\\xD4\\x8C'}='&#x50C;';
  $map{'\\xD4\\x8D'}='&#x50D;';
  $map{'\\xD4\\x8E'}='&#x50E;';
  $map{'\\xD4\\x8F'}='&#x50F;';
  $map{'\\xD4\\x90'}='&#x510;';
  $map{'\\xD4\\x91'}='&#x511;';
  $map{'\\xD4\\x92'}='&#x512;';
  $map{'\\xD4\\x93'}='&#x513;';
  $map{'\\xD4\\x94'}='&#x514;';
  $map{'\\xD4\\x95'}='&#x515;';
  $map{'\\xD4\\x96'}='&#x516;';
  $map{'\\xD4\\x97'}='&#x517;';
  $map{'\\xD4\\x98'}='&#x518;';
  $map{'\\xD4\\x99'}='&#x519;';
  $map{'\\xD4\\x9A'}='&#x51A;';
  $map{'\\xD4\\x9B'}='&#x51B;';
  $map{'\\xD4\\x9C'}='&#x51C;';
  $map{'\\xD4\\x9D'}='&#x51D;';
  $map{'\\xD4\\x9E'}='&#x51E;';
  $map{'\\xD4\\x9F'}='&#x51F;';
  $map{'\\xD4\\xA0'}='&#x520;';
  $map{'\\xD4\\xA1'}='&#x521;';
  $map{'\\xD4\\xA2'}='&#x522;';
  $map{'\\xD4\\xA3'}='&#x523;';
  $map{'\\xD4\\xA4'}='&#x524;';
  $map{'\\xD4\\xA5'}='&#x525;';
  $map{'\\xD4\\xA6'}='&#x526;';
  $map{'\\xD4\\xA7'}='&#x527;';
  $map{'\\xD4\\xA8'}='&#x528;';
  $map{'\\xD4\\xA9'}='&#x529;';
  $map{'\\xD4\\xAA'}='&#x52A;';
  $map{'\\xD4\\xAB'}='&#x52B;';
  $map{'\\xD4\\xAC'}='&#x52C;';
  $map{'\\xD4\\xAD'}='&#x52D;';
  $map{'\\xD4\\xAE'}='&#x52E;';
  $map{'\\xD4\\xAF'}='&#x52F;';
  $map{'\\xD4\\xB0'}='&#x530;';
  $map{'\\xD4\\xB1'}='&#x531;';
  $map{'\\xD4\\xB2'}='&#x532;';
  $map{'\\xD4\\xB3'}='&#x533;';
  $map{'\\xD4\\xB4'}='&#x534;';
  $map{'\\xD4\\xB5'}='&#x535;';
  $map{'\\xD4\\xB6'}='&#x536;';
  $map{'\\xD4\\xB7'}='&#x537;';
  $map{'\\xD4\\xB8'}='&#x538;';
  $map{'\\xD4\\xB9'}='&#x539;';
  $map{'\\xD4\\xBA'}='&#x53A;';
  $map{'\\xD4\\xBB'}='&#x53B;';
  $map{'\\xD4\\xBC'}='&#x53C;';
  $map{'\\xD4\\xBD'}='&#x53D;';
  $map{'\\xD4\\xBE'}='&#x53E;';
  $map{'\\xD4\\xBF'}='&#x53F;';
  $map{'\\xD5\\x80'}='&#x540;';
  $map{'\\xD5\\x81'}='&#x541;';
  $map{'\\xD5\\x82'}='&#x542;';
  $map{'\\xD5\\x83'}='&#x543;';
  $map{'\\xD5\\x84'}='&#x544;';
  $map{'\\xD5\\x85'}='&#x545;';
  $map{'\\xD5\\x86'}='&#x546;';
  $map{'\\xD5\\x87'}='&#x547;';
  $map{'\\xD5\\x88'}='&#x548;';
  $map{'\\xD5\\x89'}='&#x549;';
  $map{'\\xD5\\x8A'}='&#x54A;';
  $map{'\\xD5\\x8B'}='&#x54B;';
  $map{'\\xD5\\x8C'}='&#x54C;';
  $map{'\\xD5\\x8D'}='&#x54D;';
  $map{'\\xD5\\x8E'}='&#x54E;';
  $map{'\\xD5\\x8F'}='&#x54F;';
  $map{'\\xD5\\x90'}='&#x550;';
  $map{'\\xD5\\x91'}='&#x551;';
  $map{'\\xD5\\x92'}='&#x552;';
  $map{'\\xD5\\x93'}='&#x553;';
  $map{'\\xD5\\x94'}='&#x554;';
  $map{'\\xD5\\x95'}='&#x555;';
  $map{'\\xD5\\x96'}='&#x556;';
  $map{'\\xD5\\x97'}='&#x557;';
  $map{'\\xD5\\x98'}='&#x558;';
  $map{'\\xD5\\x99'}='&#x559;';
  $map{'\\xD5\\x9A'}='&#x55A;';
  $map{'\\xD5\\x9B'}='&#x55B;';
  $map{'\\xD5\\x9C'}='&#x55C;';
  $map{'\\xD5\\x9D'}='&#x55D;';
  $map{'\\xD5\\x9E'}='&#x55E;';
  $map{'\\xD5\\x9F'}='&#x55F;';
  $map{'\\xD5\\xA0'}='&#x560;';
  $map{'\\xD5\\xA1'}='&#x561;';
  $map{'\\xD5\\xA2'}='&#x562;';
  $map{'\\xD5\\xA3'}='&#x563;';
  $map{'\\xD5\\xA4'}='&#x564;';
  $map{'\\xD5\\xA5'}='&#x565;';
  $map{'\\xD5\\xA6'}='&#x566;';
  $map{'\\xD5\\xA7'}='&#x567;';
  $map{'\\xD5\\xA8'}='&#x568;';
  $map{'\\xD5\\xA9'}='&#x569;';
  $map{'\\xD5\\xAA'}='&#x56A;';
  $map{'\\xD5\\xAB'}='&#x56B;';
  $map{'\\xD5\\xAC'}='&#x56C;';
  $map{'\\xD5\\xAD'}='&#x56D;';
  $map{'\\xD5\\xAE'}='&#x56E;';
  $map{'\\xD5\\xAF'}='&#x56F;';
  $map{'\\xD5\\xB0'}='&#x570;';
  $map{'\\xD5\\xB1'}='&#x571;';
  $map{'\\xD5\\xB2'}='&#x572;';
  $map{'\\xD5\\xB3'}='&#x573;';
  $map{'\\xD5\\xB4'}='&#x574;';
  $map{'\\xD5\\xB5'}='&#x575;';
  $map{'\\xD5\\xB6'}='&#x576;';
  $map{'\\xD5\\xB7'}='&#x577;';
  $map{'\\xD5\\xB8'}='&#x578;';
  $map{'\\xD5\\xB9'}='&#x579;';
  $map{'\\xD5\\xBA'}='&#x57A;';
  $map{'\\xD5\\xBB'}='&#x57B;';
  $map{'\\xD5\\xBC'}='&#x57C;';
  $map{'\\xD5\\xBD'}='&#x57D;';
  $map{'\\xD5\\xBE'}='&#x57E;';
  $map{'\\xD5\\xBF'}='&#x57F;';
  $map{'\\xD6\\x80'}='&#x580;';
  $map{'\\xD6\\x81'}='&#x581;';
  $map{'\\xD6\\x82'}='&#x582;';
  $map{'\\xD6\\x83'}='&#x583;';
  $map{'\\xD6\\x84'}='&#x584;';
  $map{'\\xD6\\x85'}='&#x585;';
  $map{'\\xD6\\x86'}='&#x586;';
  $map{'\\xD6\\x87'}='&#x587;';
  $map{'\\xD6\\x88'}='&#x588;';
  $map{'\\xD6\\x89'}='&#x589;';
  $map{'\\xD6\\x8A'}='&#x58A;';
  $map{'\\xD6\\x8B'}='&#x58B;';
  $map{'\\xD6\\x8C'}='&#x58C;';
  $map{'\\xD6\\x8D'}='&#x58D;';
  $map{'\\xD6\\x8E'}='&#x58E;';
  $map{'\\xD6\\x8F'}='&#x58F;';

# START: ISO-8859-8 -> Hebrew
  $map{'\\xD6\\x90'}='&#x590;';
  $map{'\\xD6\\x91'}='&#x591;';
  $map{'\\xD6\\x92'}='&#x592;';
  $map{'\\xD6\\x93'}='&#x593;';
  $map{'\\xD6\\x94'}='&#x594;';
  $map{'\\xD6\\x95'}='&#x595;';
  $map{'\\xD6\\x96'}='&#x596;';
  $map{'\\xD6\\x97'}='&#x597;';
  $map{'\\xD6\\x98'}='&#x598;';
  $map{'\\xD6\\x99'}='&#x599;';
  $map{'\\xD6\\x9A'}='&#x59A;';
  $map{'\\xD6\\x9B'}='&#x59B;';
  $map{'\\xD6\\x9C'}='&#x59C;';
  $map{'\\xD6\\x9D'}='&#x59D;';
  $map{'\\xD6\\x9E'}='&#x59E;';
  $map{'\\xD6\\x9F'}='&#x59F;';
  $map{'\\xD6\\xA0'}='&#x5A0;';
  $map{'\\xD6\\xA1'}='&#x5A1;';
  $map{'\\xD6\\xA2'}='&#x5A2;';
  $map{'\\xD6\\xA3'}='&#x5A3;';
  $map{'\\xD6\\xA4'}='&#x5A4;';
  $map{'\\xD6\\xA5'}='&#x5A5;';
  $map{'\\xD6\\xA6'}='&#x5A6;';
  $map{'\\xD6\\xA7'}='&#x5A7;';
  $map{'\\xD6\\xA8'}='&#x5A8;';
  $map{'\\xD6\\xA9'}='&#x5A9;';
  $map{'\\xD6\\xAA'}='&#x5AA;';
  $map{'\\xD6\\xAB'}='&#x5AB;';
  $map{'\\xD6\\xAC'}='&#x5AC;';
  $map{'\\xD6\\xAD'}='&#x5AD;';
  $map{'\\xD6\\xAE'}='&#x5AE;';
  $map{'\\xD6\\xAF'}='&#x5AF;';
  $map{'\\xD6\\xB0'}='&#x5B0;';
  $map{'\\xD6\\xB1'}='&#x5B1;';
  $map{'\\xD6\\xB2'}='&#x5B2;';
  $map{'\\xD6\\xB3'}='&#x5B3;';
  $map{'\\xD6\\xB4'}='&#x5B4;';
  $map{'\\xD6\\xB5'}='&#x5B5;';
  $map{'\\xD6\\xB6'}='&#x5B6;';
  $map{'\\xD6\\xB7'}='&#x5B7;';
  $map{'\\xD6\\xB8'}='&#x5B8;';
  $map{'\\xD6\\xB9'}='&#x5B9;';
  $map{'\\xD6\\xBA'}='&#x5BA;';
  $map{'\\xD6\\xBB'}='&#x5BB;';
  $map{'\\xD6\\xBC'}='&#x5BC;';
  $map{'\\xD6\\xBD'}='&#x5BD;';
  $map{'\\xD6\\xBE'}='&#x5BE;';
  $map{'\\xD6\\xBF'}='&#x5BF;';
  $map{'\\xD7\\x80'}='&#x5C0;';
  $map{'\\xD7\\x81'}='&#x5C1;';
  $map{'\\xD7\\x82'}='&#x5C2;';
  $map{'\\xD7\\x83'}='&#x5C3;';
  $map{'\\xD7\\x84'}='&#x5C4;';
  $map{'\\xD7\\x85'}='&#x5C5;';
  $map{'\\xD7\\x86'}='&#x5C6;';
  $map{'\\xD7\\x87'}='&#x5C7;';
  $map{'\\xD7\\x88'}='&#x5C8;';
  $map{'\\xD7\\x89'}='&#x5C9;';
  $map{'\\xD7\\x8A'}='&#x5CA;';
  $map{'\\xD7\\x8B'}='&#x5CB;';
  $map{'\\xD7\\x8C'}='&#x5CC;';
  $map{'\\xD7\\x8D'}='&#x5CD;';
  $map{'\\xD7\\x8E'}='&#x5CE;';
  $map{'\\xD7\\x8F'}='&#x5CF;';
  $map{'\\xD7\\x90'}='&#x5D0;';
  $map{'\\xD7\\x91'}='&#x5D1;';
  $map{'\\xD7\\x92'}='&#x5D2;';
  $map{'\\xD7\\x93'}='&#x5D3;';
  $map{'\\xD7\\x94'}='&#x5D4;';
  $map{'\\xD7\\x95'}='&#x5D5;';
  $map{'\\xD7\\x96'}='&#x5D6;';
  $map{'\\xD7\\x97'}='&#x5D7;';
  $map{'\\xD7\\x98'}='&#x5D8;';
  $map{'\\xD7\\x99'}='&#x5D9;';
  $map{'\\xD7\\x9A'}='&#x5DA;';
  $map{'\\xD7\\x9B'}='&#x5DB;';
  $map{'\\xD7\\x9C'}='&#x5DC;';
  $map{'\\xD7\\x9D'}='&#x5DD;';
  $map{'\\xD7\\x9E'}='&#x5DE;';
  $map{'\\xD7\\x9F'}='&#x5DF;';
  $map{'\\xD7\\xA0'}='&#x5E0;';
  $map{'\\xD7\\xA1'}='&#x5E1;';
  $map{'\\xD7\\xA2'}='&#x5E2;';
  $map{'\\xD7\\xA3'}='&#x5E3;';
  $map{'\\xD7\\xA4'}='&#x5E4;';
  $map{'\\xD7\\xA5'}='&#x5E5;';
  $map{'\\xD7\\xA6'}='&#x5E6;';
  $map{'\\xD7\\xA7'}='&#x5E7;';
  $map{'\\xD7\\xA8'}='&#x5E8;';
  $map{'\\xD7\\xA9'}='&#x5E9;';
  $map{'\\xD7\\xAA'}='&#x5EA;';
  $map{'\\xD7\\xAB'}='&#x5EB;';
  $map{'\\xD7\\xAC'}='&#x5EC;';
  $map{'\\xD7\\xAD'}='&#x5ED;';
  $map{'\\xD7\\xAE'}='&#x5EE;';
  $map{'\\xD7\\xAF'}='&#x5EF;';
  $map{'\\xD7\\xB0'}='&#x5F0;';
  $map{'\\xD7\\xB1'}='&#x5F1;';
  $map{'\\xD7\\xB2'}='&#x5F2;';
  $map{'\\xD7\\xB3'}='&#x5F3;';
  $map{'\\xD7\\xB4'}='&#x5F4;';
  $map{'\\xD7\\xB5'}='&#x5F5;';
  $map{'\\xD7\\xB6'}='&#x5F6;';
  $map{'\\xD7\\xB7'}='&#x5F7;';
  $map{'\\xD7\\xB8'}='&#x5F8;';
  $map{'\\xD7\\xB9'}='&#x5F9;';
  $map{'\\xD7\\xBA'}='&#x5FA;';
  $map{'\\xD7\\xBB'}='&#x5FB;';
  $map{'\\xD7\\xBC'}='&#x5FC;';
  $map{'\\xD7\\xBD'}='&#x5FD;';
  $map{'\\xD7\\xBE'}='&#x5FE;';
  $map{'\\xD7\\xBF'}='&#x5FF;';
# END: ISO-8859-8, Hebrew

  $map{'\\xD8\\x80'}='&#x600;';
  $map{'\\xD8\\x81'}='&#x601;';
  $map{'\\xD8\\x82'}='&#x602;';
  $map{'\\xD8\\x83'}='&#x603;';
  $map{'\\xD8\\x84'}='&#x604;';
  $map{'\\xD8\\x85'}='&#x605;';
  $map{'\\xD8\\x86'}='&#x606;';
  $map{'\\xD8\\x87'}='&#x607;';
  $map{'\\xD8\\x88'}='&#x608;';
  $map{'\\xD8\\x89'}='&#x609;';
  $map{'\\xD8\\x8A'}='&#x60A;';
  $map{'\\xD8\\x8B'}='&#x60B;';
  $map{'\\xD8\\x8C'}='&#x60C;';
  $map{'\\xD8\\x8D'}='&#x60D;';
  $map{'\\xD8\\x8E'}='&#x60E;';
  $map{'\\xD8\\x8F'}='&#x60F;';
  $map{'\\xD8\\x90'}='&#x610;';
  $map{'\\xD8\\x91'}='&#x611;';
  $map{'\\xD8\\x92'}='&#x612;';
  $map{'\\xD8\\x93'}='&#x613;';
  $map{'\\xD8\\x94'}='&#x614;';
  $map{'\\xD8\\x95'}='&#x615;';
  $map{'\\xD8\\x96'}='&#x616;';
  $map{'\\xD8\\x97'}='&#x617;';
  $map{'\\xD8\\x98'}='&#x618;';
  $map{'\\xD8\\x99'}='&#x619;';
  $map{'\\xD8\\x9A'}='&#x61A;';
  $map{'\\xD8\\x9B'}='&#x61B;';
  $map{'\\xD8\\x9C'}='&#x61C;';
  $map{'\\xD8\\x9D'}='&#x61D;';
  $map{'\\xD8\\x9E'}='&#x61E;';
  $map{'\\xD8\\x9F'}='&#x61F;';
  $map{'\\xD8\\xA0'}='&#x620;';
  $map{'\\xD8\\xA1'}='&#x621;';
  $map{'\\xD8\\xA2'}='&#x622;';
  $map{'\\xD8\\xA3'}='&#x623;';
  $map{'\\xD8\\xA4'}='&#x624;';
  $map{'\\xD8\\xA5'}='&#x625;';
  $map{'\\xD8\\xA6'}='&#x626;';
  $map{'\\xD8\\xA7'}='&#x627;';
  $map{'\\xD8\\xA8'}='&#x628;';
  $map{'\\xD8\\xA9'}='&#x629;';
  $map{'\\xD8\\xAA'}='&#x62A;';
  $map{'\\xD8\\xAB'}='&#x62B;';
  $map{'\\xD8\\xAC'}='&#x62C;';
  $map{'\\xD8\\xAD'}='&#x62D;';
  $map{'\\xD8\\xAE'}='&#x62E;';
  $map{'\\xD8\\xAF'}='&#x62F;';
  $map{'\\xD8\\xB0'}='&#x630;';
  $map{'\\xD8\\xB1'}='&#x631;';
  $map{'\\xD8\\xB2'}='&#x632;';
  $map{'\\xD8\\xB3'}='&#x633;';
  $map{'\\xD8\\xB4'}='&#x634;';
  $map{'\\xD8\\xB5'}='&#x635;';
  $map{'\\xD8\\xB6'}='&#x636;';
  $map{'\\xD8\\xB7'}='&#x637;';
  $map{'\\xD8\\xB8'}='&#x638;';
  $map{'\\xD8\\xB9'}='&#x639;';
  $map{'\\xD8\\xBA'}='&#x63A;';
  $map{'\\xD8\\xBB'}='&#x63B;';
  $map{'\\xD8\\xBC'}='&#x63C;';
  $map{'\\xD8\\xBD'}='&#x63D;';
  $map{'\\xD8\\xBE'}='&#x63E;';
  $map{'\\xD8\\xBF'}='&#x63F;';
  $map{'\\xD9\\x80'}='&#x640;';
  $map{'\\xD9\\x81'}='&#x641;';
  $map{'\\xD9\\x82'}='&#x642;';
  $map{'\\xD9\\x83'}='&#x643;';
  $map{'\\xD9\\x84'}='&#x644;';
  $map{'\\xD9\\x85'}='&#x645;';
  $map{'\\xD9\\x86'}='&#x646;';
  $map{'\\xD9\\x87'}='&#x647;';
  $map{'\\xD9\\x88'}='&#x648;';
  $map{'\\xD9\\x89'}='&#x649;';
  $map{'\\xD9\\x8A'}='&#x64A;';
  $map{'\\xD9\\x8B'}='&#x64B;';
  $map{'\\xD9\\x8C'}='&#x64C;';
  $map{'\\xD9\\x8D'}='&#x64D;';
  $map{'\\xD9\\x8E'}='&#x64E;';
  $map{'\\xD9\\x8F'}='&#x64F;';
  $map{'\\xD9\\x90'}='&#x650;';
  $map{'\\xD9\\x91'}='&#x651;';
  $map{'\\xD9\\x92'}='&#x652;';
  $map{'\\xD9\\x93'}='&#x653;';
  $map{'\\xD9\\x94'}='&#x654;';
  $map{'\\xD9\\x95'}='&#x655;';
  $map{'\\xD9\\x96'}='&#x656;';
  $map{'\\xD9\\x97'}='&#x657;';
  $map{'\\xD9\\x98'}='&#x658;';
  $map{'\\xD9\\x99'}='&#x659;';
  $map{'\\xD9\\x9A'}='&#x65A;';
  $map{'\\xD9\\x9B'}='&#x65B;';
  $map{'\\xD9\\x9C'}='&#x65C;';
  $map{'\\xD9\\x9D'}='&#x65D;';
  $map{'\\xD9\\x9E'}='&#x65E;';
  $map{'\\xD9\\x9F'}='&#x65F;';
  $map{'\\xD9\\xA0'}='&#x660;';
  $map{'\\xD9\\xA1'}='&#x661;';
  $map{'\\xD9\\xA2'}='&#x662;';
  $map{'\\xD9\\xA3'}='&#x663;';
  $map{'\\xD9\\xA4'}='&#x664;';
  $map{'\\xD9\\xA5'}='&#x665;';
  $map{'\\xD9\\xA6'}='&#x666;';
  $map{'\\xD9\\xA7'}='&#x667;';
  $map{'\\xD9\\xA8'}='&#x668;';
  $map{'\\xD9\\xA9'}='&#x669;';
  $map{'\\xD9\\xAA'}='&#x66A;';
  $map{'\\xD9\\xAB'}='&#x66B;';
  $map{'\\xD9\\xAC'}='&#x66C;';
  $map{'\\xD9\\xAD'}='&#x66D;';
  $map{'\\xD9\\xAE'}='&#x66E;';
  $map{'\\xD9\\xAF'}='&#x66F;';
  $map{'\\xD9\\xB0'}='&#x670;';
  $map{'\\xD9\\xB1'}='&#x671;';
  $map{'\\xD9\\xB2'}='&#x672;';
  $map{'\\xD9\\xB3'}='&#x673;';
  $map{'\\xD9\\xB4'}='&#x674;';
  $map{'\\xD9\\xB5'}='&#x675;';
  $map{'\\xD9\\xB6'}='&#x676;';
  $map{'\\xD9\\xB7'}='&#x677;';
  $map{'\\xD9\\xB8'}='&#x678;';
  $map{'\\xD9\\xB9'}='&#x679;';
  $map{'\\xD9\\xBA'}='&#x67A;';
  $map{'\\xD9\\xBB'}='&#x67B;';
  $map{'\\xD9\\xBC'}='&#x67C;';
  $map{'\\xD9\\xBD'}='&#x67D;';
  $map{'\\xD9\\xBE'}='&#x67E;';
  $map{'\\xD9\\xBF'}='&#x67F;';
  $map{'\\xDA\\x80'}='&#x680;';
  $map{'\\xDA\\x81'}='&#x681;';
  $map{'\\xDA\\x82'}='&#x682;';
  $map{'\\xDA\\x83'}='&#x683;';
  $map{'\\xDA\\x84'}='&#x684;';
  $map{'\\xDA\\x85'}='&#x685;';
  $map{'\\xDA\\x86'}='&#x686;';
  $map{'\\xDA\\x87'}='&#x687;';
  $map{'\\xDA\\x88'}='&#x688;';
  $map{'\\xDA\\x89'}='&#x689;';
  $map{'\\xDA\\x8A'}='&#x68A;';
  $map{'\\xDA\\x8B'}='&#x68B;';
  $map{'\\xDA\\x8C'}='&#x68C;';
  $map{'\\xDA\\x8D'}='&#x68D;';
  $map{'\\xDA\\x8E'}='&#x68E;';
  $map{'\\xDA\\x8F'}='&#x68F;';
  $map{'\\xDA\\x90'}='&#x690;';
  $map{'\\xDA\\x91'}='&#x691;';
  $map{'\\xDA\\x92'}='&#x692;';
  $map{'\\xDA\\x93'}='&#x693;';
  $map{'\\xDA\\x94'}='&#x694;';
  $map{'\\xDA\\x95'}='&#x695;';
  $map{'\\xDA\\x96'}='&#x696;';
  $map{'\\xDA\\x97'}='&#x697;';
  $map{'\\xDA\\x98'}='&#x698;';
  $map{'\\xDA\\x99'}='&#x699;';
  $map{'\\xDA\\x9A'}='&#x69A;';
  $map{'\\xDA\\x9B'}='&#x69B;';
  $map{'\\xDA\\x9C'}='&#x69C;';
  $map{'\\xDA\\x9D'}='&#x69D;';
  $map{'\\xDA\\x9E'}='&#x69E;';
  $map{'\\xDA\\x9F'}='&#x69F;';
  $map{'\\xDA\\xA0'}='&#x6A0;';
  $map{'\\xDA\\xA1'}='&#x6A1;';
  $map{'\\xDA\\xA2'}='&#x6A2;';
  $map{'\\xDA\\xA3'}='&#x6A3;';
  $map{'\\xDA\\xA4'}='&#x6A4;';
  $map{'\\xDA\\xA5'}='&#x6A5;';
  $map{'\\xDA\\xA6'}='&#x6A6;';
  $map{'\\xDA\\xA7'}='&#x6A7;';
  $map{'\\xDA\\xA8'}='&#x6A8;';
  $map{'\\xDA\\xA9'}='&#x6A9;';
  $map{'\\xDA\\xAA'}='&#x6AA;';
  $map{'\\xDA\\xAB'}='&#x6AB;';
  $map{'\\xDA\\xAC'}='&#x6AC;';
  $map{'\\xDA\\xAD'}='&#x6AD;';
  $map{'\\xDA\\xAE'}='&#x6AE;';
  $map{'\\xDA\\xAF'}='&#x6AF;';
  $map{'\\xDA\\xB0'}='&#x6B0;';
  $map{'\\xDA\\xB1'}='&#x6B1;';
  $map{'\\xDA\\xB2'}='&#x6B2;';
  $map{'\\xDA\\xB3'}='&#x6B3;';
  $map{'\\xDA\\xB4'}='&#x6B4;';
  $map{'\\xDA\\xB5'}='&#x6B5;';
  $map{'\\xDA\\xB6'}='&#x6B6;';
  $map{'\\xDA\\xB7'}='&#x6B7;';
  $map{'\\xDA\\xB8'}='&#x6B8;';
  $map{'\\xDA\\xB9'}='&#x6B9;';
  $map{'\\xDA\\xBA'}='&#x6BA;';
  $map{'\\xDA\\xBB'}='&#x6BB;';
  $map{'\\xDA\\xBC'}='&#x6BC;';
  $map{'\\xDA\\xBD'}='&#x6BD;';
  $map{'\\xDA\\xBE'}='&#x6BE;';
  $map{'\\xDA\\xBF'}='&#x6BF;';
  $map{'\\xDB\\x80'}='&#x6C0;';
  $map{'\\xDB\\x81'}='&#x6C1;';
  $map{'\\xDB\\x82'}='&#x6C2;';
  $map{'\\xDB\\x83'}='&#x6C3;';
  $map{'\\xDB\\x84'}='&#x6C4;';
  $map{'\\xDB\\x85'}='&#x6C5;';
  $map{'\\xDB\\x86'}='&#x6C6;';
  $map{'\\xDB\\x87'}='&#x6C7;';
  $map{'\\xDB\\x88'}='&#x6C8;';
  $map{'\\xDB\\x89'}='&#x6C9;';
  $map{'\\xDB\\x8A'}='&#x6CA;';
  $map{'\\xDB\\x8B'}='&#x6CB;';
  $map{'\\xDB\\x8C'}='&#x6CC;';
  $map{'\\xDB\\x8D'}='&#x6CD;';
  $map{'\\xDB\\x8E'}='&#x6CE;';
  $map{'\\xDB\\x8F'}='&#x6CF;';
  $map{'\\xDB\\x90'}='&#x6D0;';
  $map{'\\xDB\\x91'}='&#x6D1;';
  $map{'\\xDB\\x92'}='&#x6D2;';
  $map{'\\xDB\\x93'}='&#x6D3;';
  $map{'\\xDB\\x94'}='&#x6D4;';
  $map{'\\xDB\\x95'}='&#x6D5;';
  $map{'\\xDB\\x96'}='&#x6D6;';
  $map{'\\xDB\\x97'}='&#x6D7;';
  $map{'\\xDB\\x98'}='&#x6D8;';
  $map{'\\xDB\\x99'}='&#x6D9;';
  $map{'\\xDB\\x9A'}='&#x6DA;';
  $map{'\\xDB\\x9B'}='&#x6DB;';
  $map{'\\xDB\\x9C'}='&#x6DC;';
  $map{'\\xDB\\x9D'}='&#x6DD;';
  $map{'\\xDB\\x9E'}='&#x6DE;';
  $map{'\\xDB\\x9F'}='&#x6DF;';
  $map{'\\xDB\\xA0'}='&#x6E0;';
  $map{'\\xDB\\xA1'}='&#x6E1;';
  $map{'\\xDB\\xA2'}='&#x6E2;';
  $map{'\\xDB\\xA3'}='&#x6E3;';
  $map{'\\xDB\\xA4'}='&#x6E4;';
  $map{'\\xDB\\xA5'}='&#x6E5;';
  $map{'\\xDB\\xA6'}='&#x6E6;';
  $map{'\\xDB\\xA7'}='&#x6E7;';
  $map{'\\xDB\\xA8'}='&#x6E8;';
  $map{'\\xDB\\xA9'}='&#x6E9;';
  $map{'\\xDB\\xAA'}='&#x6EA;';
  $map{'\\xDB\\xAB'}='&#x6EB;';
  $map{'\\xDB\\xAC'}='&#x6EC;';
  $map{'\\xDB\\xAD'}='&#x6ED;';
  $map{'\\xDB\\xAE'}='&#x6EE;';
  $map{'\\xDB\\xAF'}='&#x6EF;';
  $map{'\\xDB\\xB0'}='&#x6F0;';
  $map{'\\xDB\\xB1'}='&#x6F1;';
  $map{'\\xDB\\xB2'}='&#x6F2;';
  $map{'\\xDB\\xB3'}='&#x6F3;';
  $map{'\\xDB\\xB4'}='&#x6F4;';
  $map{'\\xDB\\xB5'}='&#x6F5;';
  $map{'\\xDB\\xB6'}='&#x6F6;';
  $map{'\\xDB\\xB7'}='&#x6F7;';
  $map{'\\xDB\\xB8'}='&#x6F8;';
  $map{'\\xDB\\xB9'}='&#x6F9;';
  $map{'\\xDB\\xBA'}='&#x6FA;';
  $map{'\\xDB\\xBB'}='&#x6FB;';
  $map{'\\xDB\\xBC'}='&#x6FC;';
  $map{'\\xDB\\xBD'}='&#x6FD;';
  $map{'\\xDB\\xBE'}='&#x6FE;';
  $map{'\\xDB\\xBF'}='&#x6FF;';
  $map{'\\xDC\\x80'}='&#x700;';
  $map{'\\xDC\\x81'}='&#x701;';
  $map{'\\xDC\\x82'}='&#x702;';
  $map{'\\xDC\\x83'}='&#x703;';
  $map{'\\xDC\\x84'}='&#x704;';
  $map{'\\xDC\\x85'}='&#x705;';
  $map{'\\xDC\\x86'}='&#x706;';
  $map{'\\xDC\\x87'}='&#x707;';
  $map{'\\xDC\\x88'}='&#x708;';
  $map{'\\xDC\\x89'}='&#x709;';
  $map{'\\xDC\\x8A'}='&#x70A;';
  $map{'\\xDC\\x8B'}='&#x70B;';
  $map{'\\xDC\\x8C'}='&#x70C;';
  $map{'\\xDC\\x8D'}='&#x70D;';
  $map{'\\xDC\\x8E'}='&#x70E;';
  $map{'\\xDC\\x8F'}='&#x70F;';
  $map{'\\xDC\\x90'}='&#x710;';
  $map{'\\xDC\\x91'}='&#x711;';
  $map{'\\xDC\\x92'}='&#x712;';
  $map{'\\xDC\\x93'}='&#x713;';
  $map{'\\xDC\\x94'}='&#x714;';
  $map{'\\xDC\\x95'}='&#x715;';
  $map{'\\xDC\\x96'}='&#x716;';
  $map{'\\xDC\\x97'}='&#x717;';
  $map{'\\xDC\\x98'}='&#x718;';
  $map{'\\xDC\\x99'}='&#x719;';
  $map{'\\xDC\\x9A'}='&#x71A;';
  $map{'\\xDC\\x9B'}='&#x71B;';
  $map{'\\xDC\\x9C'}='&#x71C;';
  $map{'\\xDC\\x9D'}='&#x71D;';
  $map{'\\xDC\\x9E'}='&#x71E;';
  $map{'\\xDC\\x9F'}='&#x71F;';
  $map{'\\xDC\\xA0'}='&#x720;';
  $map{'\\xDC\\xA1'}='&#x721;';
  $map{'\\xDC\\xA2'}='&#x722;';
  $map{'\\xDC\\xA3'}='&#x723;';
  $map{'\\xDC\\xA4'}='&#x724;';
  $map{'\\xDC\\xA5'}='&#x725;';
  $map{'\\xDC\\xA6'}='&#x726;';
  $map{'\\xDC\\xA7'}='&#x727;';
  $map{'\\xDC\\xA8'}='&#x728;';
  $map{'\\xDC\\xA9'}='&#x729;';
  $map{'\\xDC\\xAA'}='&#x72A;';
  $map{'\\xDC\\xAB'}='&#x72B;';
  $map{'\\xDC\\xAC'}='&#x72C;';
  $map{'\\xDC\\xAD'}='&#x72D;';
  $map{'\\xDC\\xAE'}='&#x72E;';
  $map{'\\xDC\\xAF'}='&#x72F;';
  $map{'\\xDC\\xB0'}='&#x730;';
  $map{'\\xDC\\xB1'}='&#x731;';
  $map{'\\xDC\\xB2'}='&#x732;';
  $map{'\\xDC\\xB3'}='&#x733;';
  $map{'\\xDC\\xB4'}='&#x734;';
  $map{'\\xDC\\xB5'}='&#x735;';
  $map{'\\xDC\\xB6'}='&#x736;';
  $map{'\\xDC\\xB7'}='&#x737;';
  $map{'\\xDC\\xB8'}='&#x738;';
  $map{'\\xDC\\xB9'}='&#x739;';
  $map{'\\xDC\\xBA'}='&#x73A;';
  $map{'\\xDC\\xBB'}='&#x73B;';
  $map{'\\xDC\\xBC'}='&#x73C;';
  $map{'\\xDC\\xBD'}='&#x73D;';
  $map{'\\xDC\\xBE'}='&#x73E;';
  $map{'\\xDC\\xBF'}='&#x73F;';
  $map{'\\xDD\\x80'}='&#x740;';
  $map{'\\xDD\\x81'}='&#x741;';
  $map{'\\xDD\\x82'}='&#x742;';
  $map{'\\xDD\\x83'}='&#x743;';
  $map{'\\xDD\\x84'}='&#x744;';
  $map{'\\xDD\\x85'}='&#x745;';
  $map{'\\xDD\\x86'}='&#x746;';
  $map{'\\xDD\\x87'}='&#x747;';
  $map{'\\xDD\\x88'}='&#x748;';
  $map{'\\xDD\\x89'}='&#x749;';
  $map{'\\xDD\\x8A'}='&#x74A;';
  $map{'\\xDD\\x8B'}='&#x74B;';
  $map{'\\xDD\\x8C'}='&#x74C;';
  $map{'\\xDD\\x8D'}='&#x74D;';
  $map{'\\xDD\\x8E'}='&#x74E;';
  $map{'\\xDD\\x8F'}='&#x74F;';
  $map{'\\xDD\\x90'}='&#x750;';
  $map{'\\xDD\\x91'}='&#x751;';
  $map{'\\xDD\\x92'}='&#x752;';
  $map{'\\xDD\\x93'}='&#x753;';
  $map{'\\xDD\\x94'}='&#x754;';
  $map{'\\xDD\\x95'}='&#x755;';
  $map{'\\xDD\\x96'}='&#x756;';
  $map{'\\xDD\\x97'}='&#x757;';
  $map{'\\xDD\\x98'}='&#x758;';
  $map{'\\xDD\\x99'}='&#x759;';
  $map{'\\xDD\\x9A'}='&#x75A;';
  $map{'\\xDD\\x9B'}='&#x75B;';
  $map{'\\xDD\\x9C'}='&#x75C;';
  $map{'\\xDD\\x9D'}='&#x75D;';
  $map{'\\xDD\\x9E'}='&#x75E;';
  $map{'\\xDD\\x9F'}='&#x75F;';
  $map{'\\xDD\\xA0'}='&#x760;';
  $map{'\\xDD\\xA1'}='&#x761;';
  $map{'\\xDD\\xA2'}='&#x762;';
  $map{'\\xDD\\xA3'}='&#x763;';
  $map{'\\xDD\\xA4'}='&#x764;';
  $map{'\\xDD\\xA5'}='&#x765;';
  $map{'\\xDD\\xA6'}='&#x766;';
  $map{'\\xDD\\xA7'}='&#x767;';
  $map{'\\xDD\\xA8'}='&#x768;';
  $map{'\\xDD\\xA9'}='&#x769;';
  $map{'\\xDD\\xAA'}='&#x76A;';
  $map{'\\xDD\\xAB'}='&#x76B;';
  $map{'\\xDD\\xAC'}='&#x76C;';
  $map{'\\xDD\\xAD'}='&#x76D;';
  $map{'\\xDD\\xAE'}='&#x76E;';
  $map{'\\xDD\\xAF'}='&#x76F;';
  $map{'\\xDD\\xB0'}='&#x770;';
  $map{'\\xDD\\xB1'}='&#x771;';
  $map{'\\xDD\\xB2'}='&#x772;';
  $map{'\\xDD\\xB3'}='&#x773;';
  $map{'\\xDD\\xB4'}='&#x774;';
  $map{'\\xDD\\xB5'}='&#x775;';
  $map{'\\xDD\\xB6'}='&#x776;';
  $map{'\\xDD\\xB7'}='&#x777;';
  $map{'\\xDD\\xB8'}='&#x778;';
  $map{'\\xDD\\xB9'}='&#x779;';
  $map{'\\xDD\\xBA'}='&#x77A;';
  $map{'\\xDD\\xBB'}='&#x77B;';
  $map{'\\xDD\\xBC'}='&#x77C;';
  $map{'\\xDD\\xBD'}='&#x77D;';
  $map{'\\xDD\\xBE'}='&#x77E;';
  $map{'\\xDD\\xBF'}='&#x77F;';
  $map{'\\xDE\\x80'}='&#x780;';
  $map{'\\xDE\\x81'}='&#x781;';
  $map{'\\xDE\\x82'}='&#x782;';
  $map{'\\xDE\\x83'}='&#x783;';
  $map{'\\xDE\\x84'}='&#x784;';
  $map{'\\xDE\\x85'}='&#x785;';
  $map{'\\xDE\\x86'}='&#x786;';
  $map{'\\xDE\\x87'}='&#x787;';
  $map{'\\xDE\\x88'}='&#x788;';
  $map{'\\xDE\\x89'}='&#x789;';
  $map{'\\xDE\\x8A'}='&#x78A;';
  $map{'\\xDE\\x8B'}='&#x78B;';
  $map{'\\xDE\\x8C'}='&#x78C;';
  $map{'\\xDE\\x8D'}='&#x78D;';
  $map{'\\xDE\\x8E'}='&#x78E;';
  $map{'\\xDE\\x8F'}='&#x78F;';
  $map{'\\xDE\\x90'}='&#x790;';
  $map{'\\xDE\\x91'}='&#x791;';
  $map{'\\xDE\\x92'}='&#x792;';
  $map{'\\xDE\\x93'}='&#x793;';
  $map{'\\xDE\\x94'}='&#x794;';
  $map{'\\xDE\\x95'}='&#x795;';
  $map{'\\xDE\\x96'}='&#x796;';
  $map{'\\xDE\\x97'}='&#x797;';
  $map{'\\xDE\\x98'}='&#x798;';
  $map{'\\xDE\\x99'}='&#x799;';
  $map{'\\xDE\\x9A'}='&#x79A;';
  $map{'\\xDE\\x9B'}='&#x79B;';
  $map{'\\xDE\\x9C'}='&#x79C;';
  $map{'\\xDE\\x9D'}='&#x79D;';
  $map{'\\xDE\\x9E'}='&#x79E;';
  $map{'\\xDE\\x9F'}='&#x79F;';
  $map{'\\xDE\\xA0'}='&#x7A0;';
  $map{'\\xDE\\xA1'}='&#x7A1;';
  $map{'\\xDE\\xA2'}='&#x7A2;';
  $map{'\\xDE\\xA3'}='&#x7A3;';
  $map{'\\xDE\\xA4'}='&#x7A4;';
  $map{'\\xDE\\xA5'}='&#x7A5;';
  $map{'\\xDE\\xA6'}='&#x7A6;';
  $map{'\\xDE\\xA7'}='&#x7A7;';
  $map{'\\xDE\\xA8'}='&#x7A8;';
  $map{'\\xDE\\xA9'}='&#x7A9;';
  $map{'\\xDE\\xAA'}='&#x7AA;';
  $map{'\\xDE\\xAB'}='&#x7AB;';
  $map{'\\xDE\\xAC'}='&#x7AC;';
  $map{'\\xDE\\xAD'}='&#x7AD;';
  $map{'\\xDE\\xAE'}='&#x7AE;';
  $map{'\\xDE\\xAF'}='&#x7AF;';
  $map{'\\xDE\\xB0'}='&#x7B0;';
  $map{'\\xDE\\xB1'}='&#x7B1;';
  $map{'\\xDE\\xB2'}='&#x7B2;';
  $map{'\\xDE\\xB3'}='&#x7B3;';
  $map{'\\xDE\\xB4'}='&#x7B4;';
  $map{'\\xDE\\xB5'}='&#x7B5;';
  $map{'\\xDE\\xB6'}='&#x7B6;';
  $map{'\\xDE\\xB7'}='&#x7B7;';
  $map{'\\xDE\\xB8'}='&#x7B8;';
  $map{'\\xDE\\xB9'}='&#x7B9;';
  $map{'\\xDE\\xBA'}='&#x7BA;';
  $map{'\\xDE\\xBB'}='&#x7BB;';
  $map{'\\xDE\\xBC'}='&#x7BC;';
  $map{'\\xDE\\xBD'}='&#x7BD;';
  $map{'\\xDE\\xBE'}='&#x7BE;';
  $map{'\\xDE\\xBF'}='&#x7BF;';
  $map{'\\xDF\\x80'}='&#x7C0;';
  $map{'\\xDF\\x81'}='&#x7C1;';
  $map{'\\xDF\\x82'}='&#x7C2;';
  $map{'\\xDF\\x83'}='&#x7C3;';
  $map{'\\xDF\\x84'}='&#x7C4;';
  $map{'\\xDF\\x85'}='&#x7C5;';
  $map{'\\xDF\\x86'}='&#x7C6;';
  $map{'\\xDF\\x87'}='&#x7C7;';
  $map{'\\xDF\\x88'}='&#x7C8;';
  $map{'\\xDF\\x89'}='&#x7C9;';
  $map{'\\xDF\\x8A'}='&#x7CA;';
  $map{'\\xDF\\x8B'}='&#x7CB;';
  $map{'\\xDF\\x8C'}='&#x7CC;';
  $map{'\\xDF\\x8D'}='&#x7CD;';
  $map{'\\xDF\\x8E'}='&#x7CE;';
  $map{'\\xDF\\x8F'}='&#x7CF;';
  $map{'\\xDF\\x90'}='&#x7D0;';
  $map{'\\xDF\\x91'}='&#x7D1;';
  $map{'\\xDF\\x92'}='&#x7D2;';
  $map{'\\xDF\\x93'}='&#x7D3;';
  $map{'\\xDF\\x94'}='&#x7D4;';
  $map{'\\xDF\\x95'}='&#x7D5;';
  $map{'\\xDF\\x96'}='&#x7D6;';
  $map{'\\xDF\\x97'}='&#x7D7;';
  $map{'\\xDF\\x98'}='&#x7D8;';
  $map{'\\xDF\\x99'}='&#x7D9;';
  $map{'\\xDF\\x9A'}='&#x7DA;';
  $map{'\\xDF\\x9B'}='&#x7DB;';
  $map{'\\xDF\\x9C'}='&#x7DC;';
  $map{'\\xDF\\x9D'}='&#x7DD;';
  $map{'\\xDF\\x9E'}='&#x7DE;';
  $map{'\\xDF\\x9F'}='&#x7DF;';
  $map{'\\xDF\\xA0'}='&#x7E0;';
  $map{'\\xDF\\xA1'}='&#x7E1;';
  $map{'\\xDF\\xA2'}='&#x7E2;';
  $map{'\\xDF\\xA3'}='&#x7E3;';
  $map{'\\xDF\\xA4'}='&#x7E4;';
  $map{'\\xDF\\xA5'}='&#x7E5;';
  $map{'\\xDF\\xA6'}='&#x7E6;';
  $map{'\\xDF\\xA7'}='&#x7E7;';
  $map{'\\xDF\\xA8'}='&#x7E8;';
  $map{'\\xDF\\xA9'}='&#x7E9;';
  $map{'\\xDF\\xAA'}='&#x7EA;';
  $map{'\\xDF\\xAB'}='&#x7EB;';
  $map{'\\xDF\\xAC'}='&#x7EC;';
  $map{'\\xDF\\xAD'}='&#x7ED;';
  $map{'\\xDF\\xAE'}='&#x7EE;';
  $map{'\\xDF\\xAF'}='&#x7EF;';
  $map{'\\xDF\\xB0'}='&#x7F0;';
  $map{'\\xDF\\xB1'}='&#x7F1;';
  $map{'\\xDF\\xB2'}='&#x7F2;';
  $map{'\\xDF\\xB3'}='&#x7F3;';
  $map{'\\xDF\\xB4'}='&#x7F4;';
  $map{'\\xDF\\xB5'}='&#x7F5;';
  $map{'\\xDF\\xB6'}='&#x7F6;';
  $map{'\\xDF\\xB7'}='&#x7F7;';
  $map{'\\xDF\\xB8'}='&#x7F8;';
  $map{'\\xDF\\xB9'}='&#x7F9;';
  $map{'\\xDF\\xBA'}='&#x7FA;';
  $map{'\\xDF\\xBB'}='&#x7FB;';
  $map{'\\xDF\\xBC'}='&#x7FC;';
  $map{'\\xDF\\xBD'}='&#x7FD;';
  $map{'\\xDF\\xBE'}='&#x7FE;';
  $map{'\\xDF\\xBF'}='&#x7FF;';

  # First do the wide characters first
  while(my($hex_key_reg,$html_char)=each(%map) ) {
    $text =~ s!$hex_key_reg!$html_char!g;
  }

  # Then do our quick and dirty UTF-8 (it's wider then latin)
  while(my($hex_key,$html_char)=each(%html) ) {
    my $hex_utf8_reg;
    if (hex("0x$hex_key") >= 192) {
      $hex_utf8_reg='\\xC3\\x'.uc(sprintf("%x",hex("0x$hex_key")-64));
    } else {
      $hex_utf8_reg='\\xC2\\x'.$hex_key;
    }
    $text =~ s!$hex_utf8_reg!$html_char!g;
  }

  # Then do the ther single byte characters
  while(my($hex_key,$html_char)=each(%html) ) {
    my $hex_latin_reg='\\x'.$hex_key;
    $text =~ s!$hex_latin_reg!$html_char!g;
  }

  return $text;
}

1;
